﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using csLTDMC;

namespace 二维高速比较
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private ushort _CardID = 0;
        private int expos_x = 0, expos_y = 0;
        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            } 
            _CardID = cardids[0];
            
            timer1.Start();
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
            comboBox3.SelectedIndex = 1;
            comboBox4.SelectedIndex = 0;
            comboBox5.SelectedIndex = 0;            
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            int remainpoint=0;
            double x_pos=0,y_pos=0;
            int runpoint=0;
            ushort current_state=0;
            ushort current_outbit=0;
          
            LTDMC.dmc_get_extra_encoder(_CardID, 0, ref expos_x);
            LTDMC.dmc_get_extra_encoder(_CardID, 1, ref expos_y);
            LTDMC.dmc_hcmp_2d_get_current_state_unit(_CardID, 0, ref remainpoint, ref x_pos, ref y_pos, ref runpoint, ref current_state, ref current_outbit);

            refleshlabel.Text = "已比较点数: " + runpoint.ToString() + "  当前x比较点位置: " + x_pos.ToString()  + "  当前y比较点位置: "
                + y_pos.ToString() + "  可添加比较点数: " + remainpoint.ToString() + "\r\n\r\n" + "  比较器状态: " + current_state.ToString() + "  当前x辅编位置: " + expos_x.ToString() + "  当前y辅编位置: " + expos_y.ToString();
        
        
        }

        private void button1_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_hcmp_2d_clear_points(_CardID,0);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            short res = 0;
            ushort comparemode = 0;
            ushort pwmenable = 0;
            ushort compareenable = 0;
            ushort cmp_outbit = 2;//高速二维比较输出端口号为out2
             if(comboBox2.Text=="比较使能")
            {
                compareenable = 1;
            }
             if (comboBox2.Text == "比较禁止")
            {
                compareenable = 0;
            }
            
            if(comboBox5.Text=="0：进入误差带后触发")
            {
                comparemode=0;
            } 
             if(comboBox5.Text=="1：进入误差带单轴等于后再触发")
            {
                comparemode=1;
            }
             if (comboBox4.Text == "PWM使能")
             {
                 pwmenable = 1;
             }
             if (comboBox4.Text == "PWM禁止")
             {
                 pwmenable = 0;
             }

             res = LTDMC.dmc_hcmp_2d_set_enable(_CardID, 0, compareenable);
             res = LTDMC.dmc_hcmp_2d_set_config_unit(_CardID, 0, comparemode, Convert.ToUInt16(comboBox1.Text), 1, Convert.ToDouble(textBox1.Text), Convert.ToUInt16(comboBox3.Text), 1, Convert.ToDouble(textBox2.Text), Convert.ToUInt16(textBox7.Text), Convert.ToInt32(textBox8.Text));
             res = LTDMC.dmc_hcmp_2d_set_pwmoutput(_CardID, 0, pwmenable, Convert.ToDouble(textBox3.Text), Convert.ToDouble(textBox4.Text), Convert.ToUInt16(textBox5.Text));
             res = LTDMC.dmc_hcmp_2d_clear_points(_CardID, 0);

            for (ushort i = 1; i < 5; i++)
            {
                res = LTDMC.dmc_hcmp_2d_add_point_unit(_CardID, 0, 1000 * i, 1000 * i, cmp_outbit);
            } 
        
        }

        private void button5_Click(object sender, EventArgs e)
        {
            ushort cmp_outbit = Convert.ToUInt16(textBox6.Text);
            short res = LTDMC.dmc_hcmp_2d_force_output(_CardID, 0, cmp_outbit);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_set_extra_encoder(_CardID, 0, 0);
            LTDMC.dmc_set_extra_encoder(_CardID, 1, 0);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Stop();
            LTDMC.dmc_board_close();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
