﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using csLTDMC;
using System.Threading;

namespace 手轮运动
{
    public partial class Form1 : Form
    {
        private ushort _CardID = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            short num = LTDMC.dmc_board_init();//获取卡数量
            if (num <= 0 || num > 8)
            {
                MessageBox.Show("初始卡失败!", "出错");
            }
            ushort _num = 0;
            ushort[] cardids = new ushort[8];
            uint[] cardtypes = new uint[8];
            short res = LTDMC.dmc_get_CardInfList(ref _num, cardtypes, cardids);
            if (res != 0)
            {
                MessageBox.Show("获取卡信息失败!");
            }
            _CardID = cardids[0];
            //
            timer1.Start();
        }
           private ushort GetAxis()
        {
            ushort axis = 0;
            if (radioButton1.Checked)
            {
                axis = 0;
            }
            else if (radioButton2.Checked)
            {
                axis = 1;
            }
            else if (radioButton3.Checked)
            {
                axis = 2;
            }            
            return axis;
        }
        private ushort GetMode()
        {
            ushort mode = 0;
            if (radioButton5.Checked)
            {
                mode = 1;
            }
            else if (radioButton6.Checked)
            {
                mode = 0;
            }
            return mode;
        }


        private void button1_Click(object sender, EventArgs e)
        {
            short res = 0;
            res = LTDMC.dmc_set_handwheel_inmode(_CardID, GetAxis(), GetMode(), decimal.ToInt32(numericUpDown1.Value), 0);//设置手轮控制方式
            res = LTDMC.dmc_handwheel_move(_CardID, GetAxis());//启动手轮控制
            if (res != 0)
            {
                MessageBox.Show("dmc_handwheel_move == " + res.ToString());
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_emg_stop(_CardID);//急停
        }

        private void button3_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            timer1.Stop();
            LTDMC.dmc_board_close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            ushort Axis_State_machine0 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, 0, ref Axis_State_machine0);
            switch (Axis_State_machine0)// 读取指定轴状态机
            {
                case 0: textBox1.Text = "轴处于未启动状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 1:
                    textBox1.Text = "轴处于启动禁止状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 2:
                    textBox1.Text = "轴处于准备启动状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 3:
                    textBox1.Text = "轴处于启动状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 4:
                    textBox1.Text = "轴处于操作使能状态";
                    textBox1.BackColor = Color.Green;
                    break;
                case 5:
                    textBox1.Text = "轴处于停止状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 6:
                    textBox1.Text = "轴处于错误触发状态";
                    textBox1.BackColor = Color.Red;
                    break;
                case 7:
                    textBox1.Text = "轴处于错误状态";
                    textBox1.BackColor = Color.Red;
                    break;
            };
            ushort Axis_State_machine1 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, 1, ref Axis_State_machine1);
            switch (Axis_State_machine1)// 读取指定轴状态机
            {
                case 0: textBox2.Text = "轴处于未启动状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 1:
                    textBox2.Text = "轴处于启动禁止状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 2:
                    textBox2.Text = "轴处于准备启动状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 3:
                    textBox2.Text = "轴处于启动状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 4:
                    textBox2.Text = "轴处于操作使能状态";
                    textBox2.BackColor = Color.Green;
                    break;
                case 5:
                    textBox2.Text = "轴处于停止状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 6:
                    textBox2.Text = "轴处于错误触发状态";
                    textBox2.BackColor = Color.Red;
                    break;
                case 7:
                    textBox2.Text = "轴处于错误状态";
                    textBox2.BackColor = Color.Red;
                    break;
            };
            ushort Axis_State_machine2 = 0;
            LTDMC.nmc_get_axis_state_machine(_CardID, 2, ref Axis_State_machine2);
            switch (Axis_State_machine2)// 读取指定轴状态机
            {
                case 0: textBox3.Text = "轴处于未启动状态";
                    textBox3.BackColor = Color.Red;
                    break;
                case 1:
                    textBox3.Text = "轴处于启动禁止状态";
                    textBox3.BackColor = Color.Red;
                    break;
                case 2:
                    textBox3.Text = "轴处于准备启动状态";
                    textBox3.BackColor = Color.Red;
                    break;
                case 3:
                    textBox3.Text = "轴处于启动状态";
                    textBox3.BackColor = Color.Red;
                    break;
                case 4:
                    textBox3.Text = "轴处于操作使能状态";
                    textBox3.BackColor = Color.Green;
                    break;
                case 5:
                    textBox3.Text = "轴处于停止状态";
                    textBox3.BackColor = Color.Red;
                    break;
                case 6:
                    textBox3.Text = "轴处于错误触发状态";
                    textBox3.BackColor = Color.Red;
                    break;
                case 7:
                    textBox3.Text = "轴处于错误状态";
                    textBox3.BackColor = Color.Red;
                    break;
            };
            ushort errcode = 0;
            LTDMC.nmc_get_errcode(_CardID, 2, ref errcode);
            if (errcode == 0)
            {
                textBox10.Text = "EtherCAT总线正常";
                textBox10.BackColor = Color.Green;
            }
            else
            {
                textBox10.Text = "EtherCAT总线出错";
                textBox10.BackColor = Color.Red;
            }

            ushort axis = GetAxis(); //轴号
            double dcurrent_speed0 = 0;//速度值
            double dcurrent_speed1 = 0;//速度值
            double dcurrent_speed2 = 0;//速度值
            //脉冲当量转换后指令值
            double dunitPos0 = 0; //
            double dunitPos1 = 0; //
            double dunitPos2 = 0; //

            LTDMC.dmc_read_current_speed_unit(_CardID, 0, ref dcurrent_speed0); // 读取轴当前速度
            LTDMC.dmc_read_current_speed_unit(_CardID, 1, ref dcurrent_speed1); // 读取轴当前速度
            LTDMC.dmc_read_current_speed_unit(_CardID, 2, ref dcurrent_speed2); // 读取轴当前速度
            textBox7.Text = dcurrent_speed0.ToString();
            textBox8.Text = dcurrent_speed1.ToString();
            textBox9.Text = dcurrent_speed2.ToString();

            LTDMC.dmc_get_position_unit(_CardID, 0, ref dunitPos0); //读取指定轴指令位置值
            LTDMC.dmc_get_position_unit(_CardID, 1, ref dunitPos1); //读取指定轴指令位置值
            LTDMC.dmc_get_position_unit(_CardID, 2, ref dunitPos2); //读取指定轴指令位置值
            textBox4.Text = dunitPos0.ToString();
            textBox5.Text = dunitPos1.ToString();
            textBox6.Text = dunitPos2.ToString();

            if (LTDMC.dmc_check_done(_CardID, 0) == 0) // 读取指定轴运动状态
            {
                textBox11.Text = "运行中";
                textBox11.BackColor = Color.Green;
            }
            else
            {
                textBox11.Text = "停止中";
                textBox11.BackColor = Color.Red;
            }
            if (LTDMC.dmc_check_done(_CardID, 1) == 0) // 读取指定轴运动状态
            {
                textBox12.Text = "运行中";
                textBox12.BackColor = Color.Green;
            }
            else
            {
                textBox12.Text = "停止中";
                textBox12.BackColor = Color.Red;
            }
            if (LTDMC.dmc_check_done(_CardID, 2) == 0) // 读取指定轴运动状态
            {
                textBox13.Text = "运行中";
                textBox13.BackColor = Color.Green;
            }
            else
            {
                textBox13.Text = "停止中";
                textBox13.BackColor = Color.Red;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            short res = 0;
            ushort MyAxisNum;
            ushort []MyAxisList=new ushort [3];
            MyAxisList[0]=0;
            MyAxisList[1]=1;
            MyAxisList[2]=2; //设置参与手轮运动的轴号列表
            int []Mymulti=new int [3];
            Mymulti[0]=1;
            Mymulti[1]=10;
            Mymulti[2]=10; //设置轴的倍率           
            
            MyAxisNum=3; //参与手轮运动的轴数
            res = LTDMC.dmc_set_handwheel_inmode_extern(_CardID, GetMode(), MyAxisNum, MyAxisList, Mymulti);            //设置多轴手轮运动控制输入方式
            res = LTDMC.dmc_handwheel_move(_CardID, MyAxisList[0]);//启动手轮运动        
            if (res != 0)
            {
                MessageBox.Show("dmc_handwheel_move == " + res.ToString());
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            LTDMC.dmc_emg_stop(_CardID); //停止手轮运动
        }

        private void button6_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_enable(_CardID, 0);
            LTDMC.nmc_set_axis_enable(_CardID, 1);
            LTDMC.nmc_set_axis_enable(_CardID, 2);
        }

        private void button7_Click(object sender, EventArgs e)
        {
            LTDMC.nmc_set_axis_disable(_CardID, 0);
            LTDMC.nmc_set_axis_disable(_CardID, 1);
            LTDMC.nmc_set_axis_disable(_CardID, 2);
        }

        private void button10_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……" + "\n");
            button10.Enabled = false;
            button11.Enabled = false;
            //Application.DoEvents();
            LTDMC.dmc_board_reset();
            LTDMC.dmc_board_close();

            for (int i = 0; i < 15; i++)//总线卡硬件复位耗时15s左右
            {
                Application.DoEvents();
                Thread.Sleep(1000);
            }

            LTDMC.dmc_board_init();
            richTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button10.Focus();
        }

        private void button11_Click(object sender, EventArgs e)
        {
            richTextBox1.Text = "";
            richTextBox1.AppendText("请勿操作，总线卡软件复位进行中……" + "\n");
            button11.Enabled = false;
            button10.Enabled = false;
            DateTime dt_start = DateTime.Now;
            short res = LTDMC.dmc_soft_reset(_CardID);
            if (res != 0)
            {
                MessageBox.Show("dmc_soft_reset == " + res.ToString());
                return;
            }
            ushort err = 0;
            while (true)
            {
                if ((DateTime.Now - dt_start).TotalMilliseconds >= 10000.0)//设置超时退出，防止死循环
                {
                    MessageBox.Show("总线复位失败!");
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                res = LTDMC.nmc_get_errcode(_CardID, 2, ref err);
                if (res == 0)
                {
                    if (err == 0)//总线复位正常完成
                    {
                        break;
                    }
                }
                else
                {
                    MessageBox.Show("nmc_get_errcode == " + res.ToString());
                    button10.Enabled = true;
                    button11.Enabled = true;
                    button11.Focus();
                    return;
                }
                Application.DoEvents();
            }
            richTextBox1.AppendText("总线卡软件复位完成,请确认总线状态");
            button10.Enabled = true;
            button11.Enabled = true;
            button11.Focus();
        }
     }
 }

