﻿Imports System.Threading
Imports System.IO
Imports System.Text


Public Class Form1
    Public _CardID As UShort
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡软件（热）复位进行中……")
        Button3.Enabled = False
        Button4.Enabled = False
        Dim dt_start As DateTime
        Dim res As Short
        Dim err As UShort
        dt_start = DateTime.Now
        res = dmc_soft_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_soft_reset == " + res.ToString())
            Return
        End If
        While True
            If (DateTime.Now - dt_start).TotalMilliseconds >= 10000.0 Then '设置超时退出，防止死循环
                MessageBox.Show("总线复位失败!")
                Button3.Enabled = True
                Button4.Enabled = True
                Button4.Focus()
                Return
            End If

            res = nmc_get_errcode(_CardID, 2, err)
            If res = 0 Then
                If err = 0 Then '总线复位正常完成
                    Exit While
                End If
            Else
                MessageBox.Show("nmc_get_errcode == " + res.ToString())
                Button3.Enabled = True
                Button4.Enabled = True
                Button4.Focus()
                Return
            End If
            Application.DoEvents()
        End While
        RichTextBox1.AppendText("总线卡软件（热）复位完成,请确认总线状态")
        Button3.Enabled = True
        Button4.Enabled = True
        Button4.Focus()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量
        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '
        _CardID = cardids(0) '
        Timer1.Start() '
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡硬件（冷）复位进行中……")
        'Button3.Enabled = False
        'Button4.Enabled = False
        dmc_board_reset()
        dmc_board_close()
        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next
        dmc_board_init()
        RichTextBox1.AppendText("总线卡硬件（冷）复位完成,请确认总线状态")
        'Button3.Enabled = True
        'Button4.Enabled = True
        'Button3.Focus()
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        nmc_set_axis_enable(_CardID, 255)
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        nmc_set_axis_disable(_CardID, 255)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim errcode As Int32
        nmc_get_errcode(_CardID, 2, errcode)
        If (errcode = 0) Then
            TextBox1.Text = "EtherCAT总线正常"
            TextBox1.BackColor = Color.Green
        Else
            TextBox1.Text = "EtherCAT总线出错"
            TextBox1.BackColor = Color.Red
        End If
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Me.Close()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Stop()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim res As Short
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡初始值复位进行中……")
        '‘Button3.Enabled = False
        'Button4.Enabled = False
        '调用该函数只是删除了文件信息，此时需要，再调用一次冷复位或者热复位重启总线才可以完全清除系统的临时缓存信息。
        res = dmc_original_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_original_reset == " + res.ToString())
            Return
        End If
        For i As Integer = 0 To 2 Step 1 '总线卡初始值复位耗时2s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next
        res = dmc_soft_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_soft_reset == " + res.ToString())
            Return
        End If
        'dmc_board_close()
        For i As Integer = 0 To 15 Step 1 '总线卡初始值复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next
        'dmc_board_init()
        RichTextBox1.AppendText("总线卡初始值复位完成,请确认总线状态")
        ' Button3.Enabled = True
        ' Button4.Enabled = True
        ' Button4.Focus()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim file1 = New OpenFileDialog()

        file1.Filter = "ini|*.ini"
        Dim res = file1.ShowDialog()
        If res = DialogResult.OK Then
            Dim str As String
            str = File.ReadAllText(file1.FileName)
            Dim buffer1 As Byte() = Encoding.UTF8.GetBytes(str)
            Dim fileincontrol As Byte() = Encoding.UTF8.GetBytes("")
            Dim filetype1 As UShort = 201
            nmc_set_cycletime(_CardID, 2, 500) '设置总线周期
            Dim ret As Short = dmc_download_memfile(_CardID, buffer1, buffer1.Length, fileincontrol, filetype1)

            If (ret = 0) Then
                MessageBox.Show("下载INI配置文件成功！")
            End If
      
        End If

    End Sub

  

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim file2 = New OpenFileDialog()

        file2.Filter = "eni|*.eni"
        Dim res = file2.ShowDialog()
        If res = DialogResult.OK Then
            Dim str As String
            str = File.ReadAllText(file2.FileName)
            Dim buffer1() As Byte = Encoding.UTF8.GetBytes(str)
            Dim fileincontrol() As Byte = Encoding.UTF8.GetBytes("")
            Dim filetype2 As UShort = 200
            Dim ret As Short = dmc_download_memfile(_CardID, buffer1, buffer1.Length, fileincontrol, filetype2)

            If (ret = 0) Then
                MessageBox.Show("下载ENI配置文件成功！")
            End If

        End If
    End Sub
End Class
