// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"
#include<math.h>
#include <process.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
	m_nAxis = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_SETCMP, OnButtonSetcmp)
	ON_BN_CLICKED(IDC_BUTTON_SET_LTC, OnButtonSetLtc)
	ON_BN_CLICKED(IDC_BUTTON_CLEARPOINT, OnButtonClearpoint)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	ON_BN_CLICKED(IDC_BUTTON_BOARD_RESET, OnButtonBoardReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	    SetTimer( IDC_TIMER, 100, NULL );

	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString string;
	double position = 0;
	DWORD dwEnd = 0;
	int iret = 0;
   	int axisX = 0;
   	int axisY = 1;
	int axisZ = 2;

	iret = dmc_get_position_unit( m_nCard,axisX,&position);          //ȡǰλ
	string.Format("Xλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION_0 )->SetWindowText( string );


    double NewSpeed = 0;
	iret = dmc_read_current_speed_unit( m_nCard,axisX,&NewSpeed );          //ȡǰٶ
	string.Format("Xٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe_0)->SetWindowText( string );


	DWORD status0 = dmc_check_done(m_nCard, axisX );           //жϵǰ״̬
	if (status0 == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS_0 )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS_0 )->SetWindowText( "ǰ״̬˶" );
	}


	int Number = 0;
    dmc_ltc_get_number(m_nCard, 0, 0, &Number);
  	string.Format("%d", Number );
	GetDlgItem( IDC_STATIC_LATCHNUM)->SetWindowText( string );

    double Latch_Pos = 0;
    dmc_ltc_get_value_unit(m_nCard, 0, 0, &Latch_Pos);
    string.Format("%.2f", Latch_Pos );
	GetDlgItem( IDC_STATIC_positon)->SetWindowText( string );

	double current_point = 0;
     long remained_points = 0,  runed_point = 0;
     dmc_hcmp_get_current_state_unit(m_nCard, 0, &remained_points, &current_point, &runed_point);
            
    string.Format("%d", current_point );
	GetDlgItem( IDC_STATIC_COMPOS)->SetWindowText( string );
    string.Format("%d", runed_point );
	GetDlgItem( IDC_STATIC_COMEDNUM)->SetWindowText( string );

	 unsigned short Axis_State_machine = 0;
    nmc_get_axis_state_machine(m_nCard, m_nAxis, &Axis_State_machine);
   	CStatic *Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS);
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };

	 unsigned short errcode = 1;
     nmc_get_errcode(m_nCard,2,&errcode);
  	 CStatic *Static1= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
     if (errcode == 0)
	 {
		
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT" );
         Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	 }
	 else
	 {
		 
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT߳" );
         Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
     }

	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
   //嵱
    dmc_set_equiv(m_nCard, 0, 1); //嵱Ϊpulse/unit   
   //λ
    dmc_set_position_unit(m_nCard, 0, 0);

    dmc_set_profile_unit(m_nCard, 0, 0, 10000, 0.1, 0.1, 0);

    dmc_pmove_unit(m_nCard, 0, 50000, 1);

	UpdateData(false);
}


void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	for (int i=0;i<8;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

	
}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

    dmc_emg_stop(m_nCard); //ֹͣ
	
}


void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	m_flag = 1;
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}


void CDMCd1Dlg::OnButtonSetcmp() 
{
	// TODO: Add your control notification handler code here

     unsigned short hcmp_0 = 0;          //Ƚ
     unsigned short axis = 0;            //
     unsigned short cmp_mode_0 = 5;      // Ƚģʽ5
     unsigned short cmp_source=1;          //ȽλԴ̶ֵ 1
     unsigned short cmp_logic=0;          //Чƽ 0͵ƽ 1ߵƽ
     int time = 100000;       //ȣλ usȡֵΧ 1us~20s
     int cmp_pos=10000;          //ӱȽλ
     int increment = 10000;  //øٱȽģʽλֵ
     int count = 4;          //øٱȽģʽȽϴ

     dmc_hcmp_set_mode(m_nCard, hcmp_0, cmp_mode_0);//ñȽ0  Ƚģʽ

     dmc_hcmp_set_config(m_nCard, hcmp_0, axis, cmp_source, cmp_logic, time);//ñȽ00ȽԴΪ

     dmc_hcmp_add_point_unit(m_nCard, hcmp_0, cmp_pos);//ñȽ0  ӱȽϵλ

     dmc_hcmp_set_liner_unit(m_nCard, hcmp_0, increment, count);//ñȽ0  ԱȽϲ
}



void CDMCd1Dlg::OnButtonSetLtc() 
{
	// TODO: Add your control notification handler code here
    unsigned short latch_0 = 0;//0            
          
	unsigned short latch_source = 1; //  Դ1
    unsigned short latch_mode = 0;  //  ģʽ 0棬1
    unsigned short latch_logic = 1; //  ʽ 0½棬1
    double filter = 100;//˲ʱ

    dmc_ltc_reset(m_nCard, latch_0);     //λ0

    dmc_ltc_set_mode(m_nCard, latch_0, latch_mode, latch_logic, filter);  //0ģʽΪ棬 

    dmc_ltc_set_source(m_nCard, latch_0, 0, latch_source); //00ԴΪ     

}

void CDMCd1Dlg::OnButtonClearpoint() 
{
	// TODO: Add your control notification handler code here
	short iret = 0;
    unsigned short hcmp = 0;  
    iret = dmc_hcmp_clear_points(m_nCard, 0);

}

void CDMCd1Dlg::OnButtonReset() 
{
	// TODO: Add your control notification handler code here
	dmc_ltc_reset(m_nCard, 0);     //λ   
}


void CDMCd1Dlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here
	nmc_set_axis_enable(m_nCard, 0);
}

void CDMCd1Dlg::OnButtonDisable() 
{
	// TODO: Add your control notification handler code here
	nmc_set_axis_disable(m_nCard, 0);	
}

void CDMCd1Dlg::OnButtonSoftReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ӲλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_board_reset();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿Ӳλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}

void CDMCd1Dlg::OnButtonBoardReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}
