// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
 	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
 	m_nAxis = 0;
	m_nAcc = 0.1;
 	m_nDec = 0.1;
 	m_nSpeed = 0.0;
 	m_nSpeedMin = 0.0;
 	m_equiv = 0.0;
 	m_stopvel = 0.0;
 	m_equiv2 = 0.0;
 	m_equiv3 = 0.0;
 	//}}AFX_DATA_INIT
 	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
 	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
 }

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	DDX_Control(pDX, IDC_COMBO_CRD, m_crd);
	DDX_Control(pDX, IDC_COMBO_AXISNO3, m_combox_axisno3);
	DDX_Control(pDX, IDC_COMBO_AXISNO2, m_combox_axisno2);
	DDX_Control(pDX, IDC_COMBO_AXISNO, m_combox_axisno);
	DDX_Text(pDX, IDC_EDIT_ACC, m_nAcc);
	DDX_Text(pDX, IDC_EDIT_DEC, m_nDec);
	DDX_Text(pDX, IDC_EDIT_SPEED, m_nSpeed);
	DDX_Text(pDX, IDC_EDIT_SPEEDMin, m_nSpeedMin);
	DDX_Text(pDX, IDC_EDIT_EQUIV, m_equiv);
	DDX_Text(pDX, IDC_EDIT_STOPVEL, m_stopvel);
	DDX_Text(pDX, IDC_EDIT_EQUIV2, m_equiv2);
	DDX_Text(pDX, IDC_EDIT_EQUIV3, m_equiv3);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_BN_CLICKED(IDC_BUTTON_EMGSTOP, OnButtonEmgstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_SETEPARAM, OnButtonSeteparam)
	ON_BN_CLICKED(IDC_BUTTON_DO2, OnButtonDo2)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
	ON_BN_CLICKED(IDC_BUTTON13, OnButton13)
	ON_BN_CLICKED(IDC_BUTTON14, OnButton14)
	ON_BN_CLICKED(IDC_BUTTON15, OnButton15)
	ON_BN_CLICKED(IDC_BUTTON16, OnButton16)
	ON_BN_CLICKED(IDC_BUTTON17, OnButton17)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	  
	SetTimer( IDC_TIMER, 100, NULL );

	m_nSpeed=3000;
	m_nSpeedMin=1000;
	m_nAcc=0.01;
	m_nDec=0.01;
	m_equiv = 1;
	m_equiv2 = 1;
	m_equiv3 = 1;
	m_stopvel = 0;

	m_combox_axisno.SetCurSel(0);
	m_combox_axisno2.SetCurSel(1); 
	m_combox_axisno3.SetCurSel(2); 
    m_crd.SetCurSel(0); 
	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
//	GetDlgItem( IDC_CHECK_LOGIC )->SetWindowText( m_bLogic?"߼":"߼򣺷");
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString string;
	double position = 0;
	int iret = 0;
	m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();
	m_nAxis3 = m_combox_axisno3.GetCurSel();

	iret = dmc_get_position_unit( m_nCard,m_nAxis,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION )->SetWindowText( string );

	iret = dmc_get_position_unit( m_nCard,m_nAxis2,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION2 )->SetWindowText( string );

	iret = dmc_get_position_unit( m_nCard,m_nAxis3,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION3 )->SetWindowText( string );

    double NewSpeed = 0;
	iret = dmc_read_current_speed_unit( m_nCard,m_nAxis,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe)->SetWindowText( string );
    
	iret = dmc_read_current_speed_unit( m_nCard,m_nAxis2,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe2)->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,m_nAxis3,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe3)->SetWindowText( string );

	//жϵǰϵ״̬
	short status = dmc_conti_get_run_state(m_nCard, m_crdnum); 
    
    switch (status)
     {
	    case 0:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "˶" );
			break;
		case 1:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ͣ" );
			break;
		case 2:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ֹͣ" );
			break;
		case 3:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "δ" );
			break;
		case 4:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "" );
			break;
        default:
			break;
    }

    unsigned short Axis_State_machine = 0;
	unsigned short Axis_State_machine1 = 0;
	unsigned short Axis_State_machine2 = 0;

    nmc_get_axis_state_machine(m_nCard, m_nAxis,  &Axis_State_machine);
	nmc_get_axis_state_machine(m_nCard, m_nAxis2, &Axis_State_machine1);
	nmc_get_axis_state_machine(m_nCard, m_nAxis3, &Axis_State_machine2);

   	CStatic *Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS1);	
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };
	Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS2);	
   
    switch (Axis_State_machine1)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };
    Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS3);
	switch (Axis_State_machine2)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };

    unsigned short errcode = 1;
    nmc_get_errcode(m_nCard,2,&errcode);
  	CStatic *Static1= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
    if (errcode == 0)
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	}
	else
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT߳" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
    }	 

	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;
    unsigned short axislist[3];
   	double  Targetpos[3];
    int posimode;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

    posimode = 1;//ģʽ
    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;

    Targetpos[0] = 3000;
    Targetpos[1] = 3000;

    iret = dmc_line_unit(m_nCard, m_crdnum, AxisNum, axislist,Targetpos, posimode);

	//UpdateData(false);
}

void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	int Max_axis = 8;
	m_crdnum = m_crd.GetCurSel();
	for (int i=0;i<Max_axis;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

	m_crdnum = m_crd.GetCurSel();
    dmc_stop_multicoor(m_nCard,m_crdnum,0); //ֹͣ
}

void CDMCd1Dlg::OnButtonEmgstop() 
{
	// TODO: Add your control notification handler code here
	//ȫͣ
	dmc_emg_stop(m_nCard);
	
}



void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}
 
void CDMCd1Dlg::OnButtonSeteparam() 
{
	// TODO: Add your control notification handler code here
 	UpdateData(true);//ˢ²
	m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
    m_nAxis2 = m_combox_axisno2.GetCurSel();
	m_nAxis3 = m_combox_axisno3.GetCurSel();

	dmc_set_equiv(m_nCard,m_nAxis,m_equiv); 
    dmc_set_equiv(m_nCard,m_nAxis2,m_equiv2); 
	dmc_set_equiv(m_nCard,m_nAxis3,m_equiv3); 

	dmc_set_vector_profile_unit(m_nCard, m_crdnum, m_nSpeedMin, m_nSpeed, m_nAcc, m_nDec, m_stopvel);

}

void CDMCd1Dlg::OnButtonDo2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	short iret = 0;
    int AxisNum = 3;
    unsigned short axislist[3];
   	double  Targetpos[3];
    int posimode;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();
	m_nAxis3 = m_combox_axisno3.GetCurSel();
	
	dmc_set_position_unit(m_nCard, m_nAxis, 3000);
    dmc_set_position_unit(m_nCard, m_nAxis2, 3000);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
	axislist[2] = m_nAxis3;

    Targetpos[0] = 0;
    Targetpos[1] = 0;
	Targetpos[2] = 3000;
    
    iret = dmc_line_unit(m_nCard, m_crdnum, AxisNum, axislist,Targetpos, posimode);
}

void CDMCd1Dlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;
    double Radius ; //岹뾶

    unsigned short axislist[3];
   	double  Targetpos[3];
    int posimode;
    int circle;
	short Arc_Dir;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
	Radius = 1500;
	Arc_Dir = 1;
    circle = 0;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;

    Targetpos[0] = 0;
    Targetpos[1] = 3000;

    iret = dmc_arc_move_radius_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Radius, Arc_Dir, circle, posimode);
}

void CDMCd1Dlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 3;
    double Radius ; //岹뾶

    unsigned short axislist[3];
   	double  Targetpos[3];
    int posimode;
    int circle;
	short Arc_Dir;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
	Radius = 1500;
	Arc_Dir = 1;
    circle = 3;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 0;
    Targetpos[1] = 3000;
    Targetpos[2] = 2000;
    iret = dmc_arc_move_radius_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Radius, Arc_Dir, circle, posimode);

}

void CDMCd1Dlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 3;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Mid_Pos[3];

    int posimode;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
    circle = -1;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 3000;
    Targetpos[1] = 3000;
    Targetpos[2] = 0;
    Mid_Pos[0] = 1500; 
    Mid_Pos[1] = 1500;
    Mid_Pos[2] = 1500;

    iret =dmc_arc_move_3points_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Mid_Pos, circle, posimode);

}

void CDMCd1Dlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 3;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Mid_Pos[3];

    int posimode;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
    circle = 3;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 0;
    Targetpos[1] = 3000;
    Targetpos[2] = 2000;
    Mid_Pos[0] = 1000;
    Mid_Pos[1] = 1000;
    Mid_Pos[2] = 1000;

    iret =dmc_arc_move_3points_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Mid_Pos, circle, posimode);

}

void CDMCd1Dlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  MaskPos[3];

    int posimode;
    int MyCount = 6;
    unsigned short Myrect_mode = 0;//ģʽ

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 3000;
    Targetpos[1] = 2000;
    Targetpos[2] = 0;
    MaskPos[0] = 700;
    MaskPos[1] = 0;
    MaskPos[2] = 0;

    iret = dmc_rectangle_move_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, MaskPos, MyCount, Myrect_mode, posimode);

}

void CDMCd1Dlg::OnButton10() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  MaskPos[3];

    int posimode;
    int MyCount = 4;
    unsigned short Myrect_mode = 1;//ģʽ

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 3000;
    Targetpos[1] = 2000;
    Targetpos[2] = 0;
    MaskPos[0] = 700;
    MaskPos[1] = 0;
    MaskPos[2] = 0;

    iret = dmc_rectangle_move_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, MaskPos, MyCount, Myrect_mode, posimode);
}

void CDMCd1Dlg::OnButton11() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];

    int posimode;
	short Arc_Dir;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
   	Arc_Dir = 1;
    circle = 0;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 0;
    Targetpos[1] = 3000;
    Targetpos[2] = 0;
    Cen_Pos[0] = 0;
    Cen_Pos[1] = 1500;
    Cen_Pos[2] = 0;

    iret =dmc_arc_move_center_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Cen_Pos, Arc_Dir, circle, posimode);
}

void CDMCd1Dlg::OnButton12() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];

    int posimode;
	short Arc_Dir;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
   	Arc_Dir = 1;
    circle = 3;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 0;
    Targetpos[1] = 3000;
    Targetpos[2] = 0;
    Cen_Pos[0] = 0;
    Cen_Pos[1] = 800;
    Cen_Pos[2] = 0;

    iret =dmc_arc_move_center_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Cen_Pos, Arc_Dir, circle, posimode);
}

void CDMCd1Dlg::OnButton13() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];

    int posimode;
	short Arc_Dir;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, -1200);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
   	Arc_Dir = 0;
    circle = 2;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 500;
    Targetpos[1] = 500;
    Targetpos[2] = 0;
    Cen_Pos[0] = 0;
    Cen_Pos[1] = 800;
    Cen_Pos[2] = 0;

    iret =dmc_arc_move_center_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Cen_Pos, Arc_Dir, circle, posimode);
}

void CDMCd1Dlg::OnButton14() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 3;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];

    int posimode;
	short Arc_Dir;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
   	Arc_Dir = 1;
    circle = 3;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 0;
    Targetpos[1] = 3000;
    Targetpos[2] = 3000;
    Cen_Pos[0] = 0;
    Cen_Pos[1] = 800;
    Cen_Pos[2] = 0;

    iret =dmc_arc_move_center_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Cen_Pos, Arc_Dir, circle, posimode);
}

void CDMCd1Dlg::OnButton15() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 3;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];

    int posimode;
	short Arc_Dir;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, -1200);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
   	Arc_Dir = 1;
    circle = 3;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 500;
    Targetpos[1] = 500;
    Targetpos[2] = 3000;
    Cen_Pos[0] = 0;
    Cen_Pos[1] = 800;
    Cen_Pos[2] = 0;

    iret =dmc_arc_move_center_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Cen_Pos, Arc_Dir, circle, posimode);	
}

void CDMCd1Dlg::OnButton16() 
{
	// TODO: Add your control notification handler code here
    UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 3;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];

    int posimode;
	short Arc_Dir;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
   	Arc_Dir = 1;
    circle = 3;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 0;
    Targetpos[1] = 3000;
    Targetpos[2] = 2000;
    Cen_Pos[0] = 0;
    Cen_Pos[1] = 1500;
    Cen_Pos[2] = 0;

    iret =dmc_arc_move_center_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Cen_Pos, Arc_Dir, circle, posimode);	
}

void CDMCd1Dlg::OnButton17() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	short iret = 0;
    int AxisNum = 2;

    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];

    int posimode;
	short Arc_Dir;
    int circle;

    m_crdnum = m_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_position_unit(m_nCard, m_nAxis, 0);
    dmc_set_position_unit(m_nCard, m_nAxis2, 0);
    dmc_set_position_unit(m_nCard, m_nAxis3, 0);

    posimode = 1;//ģʽ
   	Arc_Dir = 1;
    circle = -3;

    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis2;
    axislist[2] = m_nAxis3;
    Targetpos[0] = 2500;
    Targetpos[1] = 2500;
    Targetpos[2] = 0;
    Cen_Pos[0] = 1000;
    Cen_Pos[1] = 1000;
    Cen_Pos[2] = 0;

    iret =dmc_arc_move_center_unit(m_nCard, m_crdnum, AxisNum, axislist, Targetpos, Cen_Pos, Arc_Dir, circle, posimode);
}

void CDMCd1Dlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	m_nAxis = m_combox_axisno.GetCurSel();
    m_nAxis2 = m_combox_axisno2.GetCurSel();
	m_nAxis3 = m_combox_axisno3.GetCurSel();
		
	nmc_set_axis_enable(m_nCard, m_nAxis);		
	nmc_set_axis_enable(m_nCard, m_nAxis2);
	nmc_set_axis_enable(m_nCard, m_nAxis3);

}

void CDMCd1Dlg::OnButtonDisable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²	
	m_nAxis = m_combox_axisno.GetCurSel();
    m_nAxis2 = m_combox_axisno2.GetCurSel();
	m_nAxis3 = m_combox_axisno3.GetCurSel();

	nmc_set_axis_disable(m_nCard, m_nAxis);
	nmc_set_axis_disable(m_nCard, m_nAxis2);
	nmc_set_axis_disable(m_nCard, m_nAxis3);
}

void CDMCd1Dlg::OnButtonReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ӲλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_board_reset();
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿Ӳλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);
}

void CDMCd1Dlg::OnButtonSoftReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}
