// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
	m_nAxis = 0;
	m_nAcc = 0.1;
	m_nDec = 0.1;
	m_nSPara = 0.0;
	m_nSpeed = 0.0;
	m_nSpeedMin = 0.0;
	m_equiv = 0.0;
	m_stopvel = 0.0;
	m_equiv1 = 0.0;
	m_equiv2 = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	DDX_Control(pDX, IDC_COMBO_AXISNO2, m_combox_axisno2);
	DDX_Control(pDX, IDC_COMBO_AXISNO1, m_combox_axisno1);
	DDX_Control(pDX, IDC_COMBO_CRD, m_combo_crd);
	DDX_Control(pDX, IDC_COMBO_AXISNO, m_combox_axisno);
	DDX_Text(pDX, IDC_EDIT_ACC, m_nAcc);
	DDX_Text(pDX, IDC_EDIT_DEC, m_nDec);
	DDX_Text(pDX, IDC_EDIT_SPara, m_nSPara);
	DDX_Text(pDX, IDC_EDIT_SPEED, m_nSpeed);
	DDX_Text(pDX, IDC_EDIT_SPEEDMin, m_nSpeedMin);
	DDX_Text(pDX, IDC_EDIT_EQUIV, m_equiv);
	DDX_Text(pDX, IDC_EDIT_STOPVEL, m_stopvel);
	DDX_Text(pDX, IDC_EDIT_EQUIV1, m_equiv1);
	DDX_Text(pDX, IDC_EDIT_EQUIV2, m_equiv2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_BN_CLICKED(IDC_BUTTON_EMGSTOP, OnButtonEmgstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, OnButtonPause)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON_CLEARERROR, OnButtonClearerror)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	    SetTimer( IDC_TIMER, 100, NULL );

	m_nSpeed=3000;
	m_nSpeedMin=1000;
	m_nAcc=0.01;
	m_nDec=0.01;
	m_nSPara= 0;      //ʼٶ߲
	m_equiv = 1;
	m_equiv1 = 1;
	m_equiv2 = 1;
	m_stopvel = 0;
	m_combox_axisno.SetCurSel(0); 
	m_combox_axisno1.SetCurSel(1); 
	m_combox_axisno2.SetCurSel(2); 

	m_combo_crd.SetCurSel(0); 
	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
//	GetDlgItem( IDC_CHECK_LOGIC )->SetWindowText( m_bLogic?"߼":"߼򣺷");
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString string;
	double position = 0;
	double NewSpeed = 0;
	int iret = 0;
   	int remain = 0;
	int mark = 0;
	int crd = 0;
	CStatic *Static[6]= {(CStatic *)GetDlgItem(IDC_STATIC_IO0),(CStatic *)GetDlgItem(IDC_STATIC_IO1),(CStatic *)GetDlgItem(IDC_STATIC_IO2),(CStatic *)GetDlgItem(IDC_STATIC_IO3),(CStatic *)GetDlgItem(IDC_STATIC_IO4),(CStatic *)GetDlgItem(IDC_STATIC_IO5)};

   	crd = m_combo_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis1 = m_combox_axisno1.GetCurSel();
    m_nAxis2 = m_combox_axisno2.GetCurSel();

	iret = dmc_get_position_unit( m_nCard,m_nAxis,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION )->SetWindowText( string );

    iret = dmc_get_position_unit( m_nCard,m_nAxis1,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION1 )->SetWindowText( string );

	iret = dmc_get_position_unit( m_nCard,m_nAxis2,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION2 )->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,m_nAxis,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe)->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,m_nAxis1,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe1)->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,m_nAxis2,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe2)->SetWindowText( string );

    //жϵǰϵ״̬
	short status = dmc_conti_get_run_state(m_nCard, crd); 

    switch (status)
     {
	    case 0:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "˶" );
			break;
		case 1:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ͣ" );
			break;
		case 2:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ֹͣ" );
			break;
		case 3:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "δ" );
			break;
		case 4:
			GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "" );
			break;
        default:
			break;
    }
  
	remain = dmc_conti_remain_space(m_nCard, crd);
	string.Format("ʣ໺%d", remain );
  	GetDlgItem( IDC_STATIC_STATUS_REMAIN)->SetWindowText( string );

    mark = dmc_conti_read_current_mark(m_nCard, crd);
	string.Format("ǰ岹Σ%d", mark );
  	GetDlgItem( IDC_STATIC_STATUS_MARK)->SetWindowText( string );


	unsigned short errcode = 1;
    nmc_get_errcode(m_nCard,4,&errcode);
	CStatic *Static1= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
    if (errcode == 0)
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬Ethercat" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	}
	else
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬Ethercat߳" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
    }

	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
	int ioclearCheck = 0;
    int blendCheck = 0;
	int AxisNum = 3;
    unsigned short axislist[3];
   	double  Targetpos[3];
	double  Cen_Pos[3];
    int crd = 0;
    double PI = 3.141592654;

	crd = m_combo_crd.GetCurSel();
	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis1 = m_combox_axisno1.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	if (dmc_check_done( m_nCard,m_nAxis ) == 0 && dmc_check_done( m_nCard,m_nAxis1 ) == 0 && dmc_check_done( m_nCard,m_nAxis2 ) == 0) //Ѿ˶
		return; 
    axislist[0] = m_nAxis;
    axislist[1] = m_nAxis1;
    axislist[2] = m_nAxis2;

	dmc_conti_open_list(m_nCard, crd, AxisNum, axislist);
    
	dmc_set_vector_profile_unit(m_nCard, crd, m_nSpeedMin, m_nSpeed, m_nAcc, m_nDec, m_stopvel);
     
	Targetpos[0] = -2000;
    Targetpos[1] = 0;
    Targetpos[2] = 1000;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 

    Targetpos[0] = 0;
    Targetpos[1] = 2000;
    Targetpos[2] = 0;
	Cen_Pos[0] = -1000;
    Cen_Pos[1] = 1000;
    Cen_Pos[2] = 1000;
    dmc_conti_arc_move_3points_unit(m_nCard, crd, AxisNum, axislist, Targetpos, Cen_Pos, -1, 0, 0);


	Targetpos[0] = 2000;
    Targetpos[1] = 0;
    Targetpos[2] = -1000;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 

	Targetpos[0] = 0;
    Targetpos[1] = -2000;
    Targetpos[2] = 0;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 

	Targetpos[0] =1000;
    Targetpos[1] = 100;
    Targetpos[2] = 1000;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 
	
	Targetpos[0] =-1000;
    Targetpos[1] = 500;
    Targetpos[2] = 100;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 

	Targetpos[0] =1000;
    Targetpos[1] = -200;
    Targetpos[2] = 100;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 
			
	
	Targetpos[0] =-1000;
    Targetpos[1] = 1000;
    Targetpos[2] = 800;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 
	
	Targetpos[0] =1000;
    Targetpos[1] = -500;
    Targetpos[2] = 700;
	dmc_conti_line_unit(m_nCard, crd, AxisNum, axislist, Targetpos, 0, 0); 

	dmc_conti_start_list(m_nCard, crd);
	dmc_conti_close_list(m_nCard, crd);


	UpdateData(false);

}

void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	int MaxAxis = 8;
	for (int i=0;i<MaxAxis;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

	
}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

	int crd = m_combo_crd.GetCurSel();
	dmc_conti_stop_list(m_nCard, crd, 0); //ֹͣ
    GetDlgItem( IDC_BUTTON_PAUSE )->SetWindowText( "ͣ岹" );
	
}

void CDMCd1Dlg::OnButtonEmgstop() 
{
	// TODO: Add your control notification handler code here
	//ȫͣ
	int crd = m_combo_crd.GetCurSel();
	dmc_conti_stop_list(m_nCard, crd, 1); //ֹͣ
	GetDlgItem( IDC_BUTTON_PAUSE )->SetWindowText( "ͣ岹" );
}



void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}
 



void CDMCd1Dlg::OnButtonPause() 
{
	// TODO: Add your control notification handler code here
	int crd = m_combo_crd.GetCurSel();
	if (dmc_conti_get_run_state(m_nCard, crd) == 0)
    {
		dmc_conti_pause_list(m_nCard, crd);
        GetDlgItem( IDC_BUTTON_PAUSE )->SetWindowText( "岹" );
    }
    else if(dmc_conti_get_run_state(m_nCard, crd) == 1)
    {
		dmc_conti_start_list(m_nCard, crd);
              
        GetDlgItem( IDC_BUTTON_PAUSE )->SetWindowText( "ͣ岹" );
    }
}

void CDMCd1Dlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²

	m_nAxis = m_combox_axisno.GetCurSel();
	m_nAxis1 = m_combox_axisno1.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();

	dmc_set_equiv(m_nCard,m_nAxis,m_equiv);  
   	dmc_set_equiv(m_nCard,m_nAxis1,m_equiv1); 
   	dmc_set_equiv(m_nCard,m_nAxis2,m_equiv2); 

	nmc_set_axis_enable(m_nCard, m_nAxis);		
	nmc_set_axis_enable(m_nCard, m_nAxis1);
	nmc_set_axis_enable(m_nCard, m_nAxis2);

}

void CDMCd1Dlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²	
	m_nAxis = m_combox_axisno.GetCurSel();
    m_nAxis1 = m_combox_axisno1.GetCurSel();
	m_nAxis2 = m_combox_axisno2.GetCurSel();
	
	nmc_set_axis_disable(m_nCard, m_nAxis);
	nmc_set_axis_disable(m_nCard, m_nAxis1);
	nmc_set_axis_disable(m_nCard, m_nAxis2);
}

void CDMCd1Dlg::OnButtonClearerror() 
{
	// TODO: Add your control notification handler code here
	short err = 0; 	
    err = nmc_clear_axis_errcode(m_nCard, 255);	
}

void CDMCd1Dlg::OnButtonReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ӲλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_board_reset();
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿Ӳλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}

void CDMCd1Dlg::OnButtonSoftReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
	
}
