// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
	m_ratio = 0;
	m_handmode = -1;
	m_radioaxis = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	DDX_Text(pDX, IDC_EDIT_RATIO, m_ratio);
	DDX_Radio(pDX, IDC_RADIO_AB, m_handmode);
	DDX_Radio(pDX, IDC_RADIO_X, m_radioaxis);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON6_DISABLE, OnButton6Disable)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_MULTI, OnButtonMulti)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	    SetTimer( IDC_TIMER, 100, NULL );

	m_radioaxis = 0;
	m_handmode = 0;
	m_ratio = 1;
	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
//	GetDlgItem( IDC_CHECK_LOGIC )->SetWindowText( m_bLogic?"߼":"߼򣺷");
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	CString string;
	double position = 0;
	int iret = 0;
  	int axisX = 0;
   	int axisY = 1;
	int axisZ = 2;

	iret = dmc_get_position_unit( m_nCard,axisX,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION )->SetWindowText( string );

	iret = dmc_get_position_unit( m_nCard,axisY,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION2 )->SetWindowText( string );

	iret = dmc_get_position_unit( m_nCard,axisZ,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION3 )->SetWindowText( string );

    double NewSpeed = 0;
	iret = dmc_read_current_speed_unit( m_nCard,axisX,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe)->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,axisY,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe2)->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,axisZ,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe3)->SetWindowText( string );

	DWORD status = dmc_check_done(m_nCard, axisX );           //жϵǰ״̬
	if (status == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ǰ״̬˶" );
	}

	DWORD status1 = dmc_check_done(m_nCard, axisY );           //жϵǰ״̬
	if (status1 == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS2 )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS2 )->SetWindowText( "ǰ״̬˶" );
	}

    DWORD status2 = dmc_check_done(m_nCard, axisZ );           //жϵǰ״̬
	if (status2 == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS3)->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS3 )->SetWindowText( "ǰ״̬˶" );
	}

	unsigned short Axis_State_machine = 0;
	unsigned short Axis_State_machine1 = 0;
	unsigned short Axis_State_machine2 = 0;

    nmc_get_axis_state_machine(m_nCard, axisX,  &Axis_State_machine);
	nmc_get_axis_state_machine(m_nCard, axisY, &Axis_State_machine1);
	nmc_get_axis_state_machine(m_nCard, axisZ, &Axis_State_machine2);

   	CStatic *Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS1);	
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };
	Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS2);	
   
    switch (Axis_State_machine1)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };
    Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS3);
	switch (Axis_State_machine2)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };

    unsigned short errcode = 1;
    nmc_get_errcode(m_nCard,2,&errcode);
  	CStatic *Static1= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
    if (errcode == 0)
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	}
	else
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT߳" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
    }	
	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²

	dmc_set_handwheel_inmode(m_nCard, m_radioaxis, m_handmode, m_ratio, 0);
    dmc_handwheel_move(m_nCard, m_radioaxis);

	UpdateData(false);
}

void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	for (int i=0;i<8;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

	
}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

    dmc_emg_stop(m_nCard); //ֹͣ
	
}

//DEL void CDMCd1Dlg::OnButtonEmgstop() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	//ȫͣ
//DEL 	dmc_emg_stop(m_nCard);
//DEL 	
//DEL }



void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}
 


//DEL void CDMCd1Dlg::OnButtonChangespeed() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	UpdateData(true);//ˢ²
//DEL 
//DEL 	m_nAxis = m_combox_axisno.GetCurSel();
//DEL 
//DEL 	dmc_change_speed_unit(m_nCard, m_nAxis, m_nSpeed, m_nAcc);  
//DEL 
//DEL }


//DEL void CDMCd1Dlg::OnButtonSetequiv() 
//DEL {
//DEL 	// TODO: Add your control notification handler code here
//DEL 	UpdateData(true);//ˢ²
//DEL 	m_nAxis = m_combox_axisno.GetCurSel();
//DEL 	dmc_set_equiv(m_nCard,m_nAxis,m_equiv);          
//DEL }

void CDMCd1Dlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here
			
	nmc_set_axis_enable(m_nCard, 0);		
	nmc_set_axis_enable(m_nCard, 1);
	nmc_set_axis_enable(m_nCard, 2);
}

void CDMCd1Dlg::OnButton6Disable() 
{
	// TODO: Add your control notification handler code here
	nmc_set_axis_disable(m_nCard, 0);
	nmc_set_axis_disable(m_nCard, 1);
	nmc_set_axis_disable(m_nCard, 2);
}

void CDMCd1Dlg::OnButtonReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ӲλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_board_reset();
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿Ӳλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);		
}


void CDMCd1Dlg::OnButtonMulti() 
{
	// TODO: Add your control notification handler code here
   unsigned short  MyAxisNum;
   unsigned short  MyAxisList[3];
   MyAxisList[0]=0;
   MyAxisList[1]=1;
   MyAxisList[2]=2; //ò˶б
   long Mymulti[3];
   Mymulti[0]=1;
   Mymulti[1]=10;
   Mymulti[2]=10; //ı           
            
   MyAxisNum=3; //˶
   dmc_set_handwheel_inmode_extern(m_nCard, m_handmode, MyAxisNum, MyAxisList, Mymulti);            //ö˶뷽ʽ
   dmc_handwheel_move(m_nCard, MyAxisList[0]);
   //dmc_handwheel_move(m_nCard, MyAxisList[1]);
   //dmc_handwheel_move(m_nCard, MyAxisList[2]);//˶   	
}

void CDMCd1Dlg::OnButtonSoftReset() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}
