// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
	m_nAxis = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	SetTimer( IDC_TIMER, 100, NULL );

	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
//	GetDlgItem( IDC_CHECK_LOGIC )->SetWindowText( m_bLogic?"߼":"߼򣺷");
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString string;
	double position = 0;
	int iret = 0;
	iret = dmc_get_position_unit( m_nCard,0,&position);          //ȡǰλ
	string.Format("Xλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION )->SetWindowText( string );

    double NewSpeed = 0;
	iret = dmc_read_current_speed_unit( m_nCard,0,&NewSpeed );          //ȡǰٶ
	string.Format("Xٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe)->SetWindowText( string );

	DWORD status = dmc_check_done(m_nCard, 0 );           //жϵǰ״̬
	if (status == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ǰ״̬˶" );
	}

    iret = dmc_get_position_unit( m_nCard,1,&position);          //ȡǰλ
	string.Format("Yλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION2 )->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,1,&NewSpeed );          //ȡǰٶ
	string.Format("Yٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe2)->SetWindowText( string );

    status = dmc_check_done(m_nCard, 1 );           //жϵǰ״̬
	if (status == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS2 )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS2 )->SetWindowText( "ǰ״̬˶" );
	}


	//io
	CStatic *Static0= (CStatic *)GetDlgItem(IDC_STATIC_OUT0);
  	CStatic *Static3= (CStatic *)GetDlgItem(IDC_STATIC_OUT3);
  
	if (dmc_read_outbit(m_nCard,  19) == 0)
    {
		Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
    }
	else
	{
		Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
    }


    unsigned short Axis_State_machine = 0;
    nmc_get_axis_state_machine(m_nCard, 0, &Axis_State_machine);
   	CStatic *Static5= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUSX);
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦδ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦֹ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦ׼״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦڲʹ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦֹͣ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machineX )->SetWindowText( "ᴦڴ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };

    nmc_get_axis_state_machine(m_nCard, 1, &Axis_State_machine);
   	Static5= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUSY);
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦδ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦֹ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦ׼״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦڲʹ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦֹͣ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machineY )->SetWindowText( "ᴦڴ״̬" );
         Static5->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };

	 unsigned short errcode = 1;
     nmc_get_errcode(m_nCard,2,&errcode);
  	 CStatic *Static6= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
     if (errcode == 0)
	 {
		
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT" );
         Static6->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	 }
	 else
	 {
		 
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT߳" );
         Static6->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
     }

	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
    short iret=0;

    unsigned short axislist[2];
   	long  Targetpos[2]; 
	double  dTargetpos[2]; 
	double  dCen_Pos[2]; 
	unsigned short dir[2];
	WORD action = 0;
	DWORD actpara = 0;
    axislist[0] = 0;
    axislist[1] = 1;
	dmc_set_position_unit(m_nCard, 0, 0); 
	dmc_set_position_unit(m_nCard, 1, 0); //Ϊ̵չʾʼλù
	
	dmc_compare_set_config(m_nCard, 0, 1,0);
	dmc_compare_clear_points(m_nCard, 0);
	
    
	
    dmc_compare_set_config(m_nCard, 1, 1, 0);//ñȽ0ſ1һάλñȽʹܣȽԴָλ
    dmc_compare_clear_points(m_nCard, 1);//Ƚ
    
   

	
    dmc_compare_add_point_cycle_unit(m_nCard, 0, 3000, 1, 19, 0,0);//0300019õ͵ƽ
    dmc_compare_add_point_cycle_unit(m_nCard, 1, 6000, 1, 19, 0,1);//1600019øߵƽ

    dmc_set_vector_profile_unit(m_nCard, 0, 0, 2000, 0.1, 0.1, 0);// X Yֱ߲岹˶

    dTargetpos[0] = 10000;
    dTargetpos[1] = 10000;
    iret = dmc_line_unit(m_nCard, 0, 2, axislist,dTargetpos, 1);
}

void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	for (int i=0;i<8;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

	
}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

    dmc_emg_stop(m_nCard); //ֹͣ
	
}



void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}
 



void CDMCd1Dlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here

	nmc_set_axis_enable(m_nCard, 0);
	nmc_set_axis_enable(m_nCard, 1);
}

void CDMCd1Dlg::OnButtonDisable() 
{
	// TODO: Add your control notification handler code here
	nmc_set_axis_disable(m_nCard, 0);
	nmc_set_axis_disable(m_nCard, 1);	
}

void CDMCd1Dlg::OnButtonReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ӲλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_board_reset();
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿Ӳλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}

void CDMCd1Dlg::OnButtonSoftReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}
