﻿Public Class Form1
    Public _CardID As UShort
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If

        dmc_get_CardInfList(n, cardtypes, cardids) '

        _CardID = cardids(0) '

        ComboBox1.SelectedIndex = 0
        ComboBox2.SelectedIndex = 0
        ComboBox3.SelectedIndex = 1
        ComboBox4.SelectedIndex = 0
        ComboBox5.SelectedIndex = 0

        Timer1.Start() '
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim remainpoint As Integer = 0
        Dim x_pos As Double = 0
        Dim y_pos As Double = 0
        Dim runpoint As Integer = 0
        Dim current_state As UShort = 0
        Dim current_point As Integer = 0
        Dim expos_x As Integer = 0
        Dim expos_y As Integer = 0
        Dim current_outbit As UShort = 0

        dmc_get_extra_encoder(_CardID, 0, expos_x)
        dmc_get_extra_encoder(_CardID, 1, expos_y)
        dmc_hcmp_2d_get_current_state_unit(_CardID, 0, remainpoint, x_pos, y_pos, runpoint, current_state, current_outbit)

        refleshlabel.Text = "已比较点数: " + runpoint.ToString() + "  当前x比较点位置: " + x_pos.ToString() + "  当前y比较点位置: " + y_pos.ToString() + "  可添加比较点数: " + remainpoint.ToString() + vbCrLf + vbCrLf + "  比较器状态: " + current_state.ToString() + "  当前x辅编位置: " + expos_x.ToString() + "  当前y辅编位置: " + expos_y.ToString()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        dmc_hcmp_2d_clear_points(_CardID, 0)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim comparemode As UShort = 0
        Dim pwmenable As UShort = 0
        Dim compareenable As UShort = 0
        Dim cmp_outbit As UShort = 2 '高速二维比较输出端口号为out2
        If (ComboBox1.Text = "比较禁止") Then
            compareenable = 0
        End If

        If (ComboBox1.Text = "比较使能") Then
            compareenable = 1
        End If

        If (ComboBox5.Text = "0：进入误差带后触发") Then
            comparemode = 0
        End If

        If (ComboBox5.Text = "1：进入误差带单轴等于后再触发") Then
            comparemode = 1
        End If

        If (ComboBox4.Text = "PWM使能") Then
            pwmenable = 1
        End If
        If (ComboBox4.Text = "PWM禁止") Then
            pwmenable = 0
        End If

        dmc_hcmp_2d_set_enable(_CardID, 0, compareenable)

        dmc_hcmp_2d_set_config_unit(_CardID, 0, comparemode, Convert.ToUInt16(ComboBox2.Text), 1, Convert.ToDouble(TextBox7.Text), Convert.ToUInt16(ComboBox3.Text), 1, Convert.ToDouble(TextBox8.Text), Convert.ToUInt16(TextBox1.Text), Convert.ToInt32(TextBox2.Text))

        dmc_hcmp_2d_set_pwmoutput(_CardID, 0, pwmenable, Convert.ToDouble(TextBox4.Text), Convert.ToDouble(TextBox5.Text), Convert.ToUInt16(TextBox6.Text))

        dmc_hcmp_2d_clear_points(_CardID, 0)

        dmc_hcmp_2d_add_point_unit(_CardID, 0, 1000, 1000, cmp_outbit)
        dmc_hcmp_2d_add_point_unit(_CardID, 0, 2000, 2000, cmp_outbit)
        dmc_hcmp_2d_add_point_unit(_CardID, 0, 3000, 3000, cmp_outbit)
        dmc_hcmp_2d_add_point_unit(_CardID, 0, 4000, 4000, cmp_outbit)

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        dmc_set_extra_encoder(_CardID, 0, 0)
        dmc_set_extra_encoder(_CardID, 1, 0)
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Stop()
        dmc_board_close()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Me.Close()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim cmp_outbit As UShort = Convert.ToUInt16(TextBox3.Text) '高速二维比较输出端口号为out2
        dmc_hcmp_2d_force_output(_CardID, 0, cmp_outbit)
    End Sub
End Class
