﻿Imports System.Threading

Public Class Form1

    Public _CardID As UShort

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '
        _CardID = cardids(0) '
        Timer1.Start() '

    End Sub

    Private Function GetAxis() As UShort

        Return Decimal.ToUInt16(numericUpDown1.Value) '

    End Function

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        Dim axis As UShort
        Dim dist As Double
        Dim res As Short
        axis = GetAxis() '
        dmc_set_profile_unit(_CardID,
                axis,
                Decimal.ToDouble(numericUpDown3.Value),
                Decimal.ToDouble(numericUpDown4.Value),
                Decimal.ToDouble(numericUpDown5.Value),
                Decimal.ToDouble(numericUpDown6.Value),
                Decimal.ToDouble(numericUpDown8.Value)) '
        dmc_set_s_profile(_CardID, axis, 0, Decimal.ToDouble(numericUpDown7.Value)) '
        dist = Decimal.ToDouble(numericUpDown9.Value) '
        res = dmc_pmove_unit(_CardID, axis, dist, 0) '
        If res <> 0 Then
            MessageBox.Show("dmc_pmove_unit == " + res.ToString())
        End If

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim axis As UShort
        Dim s As Double
        Dim up As Double
        Dim ep As Double
        Dim errcode As Int32
        Dim Axis_State_machine As Int32

        nmc_get_errcode(_CardID, 2, errcode)
        If (errcode = 0) Then
            TextBox6.Text = "EtherCAT总线正常"
            TextBox6.BackColor = Color.Green
        Else
            TextBox6.Text = "EtherCAT总线出错"
            TextBox6.BackColor = Color.Red
        End If

        nmc_get_axis_state_machine(_CardID, GetAxis(), Axis_State_machine)
        Select Case (Axis_State_machine) ' 读取指定轴状态机

            Case 0 : TextBox5.Text = "轴处于未启动状态"
                TextBox5.BackColor = Color.Red

            Case 1
                TextBox5.Text = "轴处于启动禁止状态"
                TextBox5.BackColor = Color.Red

            Case 2
                TextBox5.Text = "轴处于准备启动状态"
                TextBox5.BackColor = Color.Red

            Case 3
                TextBox5.Text = "轴处于启动状态"
                TextBox5.BackColor = Color.Red

            Case 4
                TextBox5.Text = "轴处于操作使能状态"
                TextBox5.BackColor = Color.Green

            Case 5
                TextBox5.Text = "轴处于停止状态"
                TextBox5.BackColor = Color.Red

            Case 6
                TextBox5.Text = "轴处于错误触发状态"
                TextBox5.BackColor = Color.Red

            Case 7
                TextBox5.Text = "轴处于错误状态"
                TextBox5.BackColor = Color.Red

        End Select



        axis = GetAxis() '
        dmc_read_current_speed_unit(_CardID, axis, s) '
        textBox1.Text = Str(s) '
        dmc_get_position_unit(_CardID, axis, up) '
        textBox2.Text = Str(up) '
        dmc_get_encoder_unit(_CardID, axis, ep) '
        textBox3.Text = Str(ep) '

        If (dmc_check_done(_CardID, axis) = 0) Then
            textBox4.Text = "运行中" '
            textBox4.BackColor = Color.Green
        Else
            textBox4.Text = "停止中" '
            textBox4.BackColor = Color.Red
        End If

    End Sub

    Private Sub button4_Click(sender As Object, e As EventArgs) Handles button4.Click
        dmc_stop(_CardID, GetAxis(), 1) '
    End Sub

    Private Sub button5_Click(sender As Object, e As EventArgs) Handles button5.Click
        dmc_set_position_unit(_CardID, GetAxis(), 0) '
    End Sub

    Private Sub button7_Click(sender As Object, e As EventArgs) Handles button7.Click
        Me.Close() '
    End Sub

    Private Sub button6_Click(sender As Object, e As EventArgs) Handles button6.Click
        Dim res As Short
        res = dmc_set_equiv(_CardID, GetAxis(), Decimal.ToDouble(numericUpDown2.Value)) '
        If res <> 0 Then
            MessageBox.Show("dmc_set_equiv == " + res.ToString())
        End If
    End Sub

    Private Sub button2_Click(sender As Object, e As EventArgs) Handles button2.Click
        Dim res As Short
        res = dmc_change_speed_unit(_CardID, GetAxis(), Decimal.ToDouble(numericUpDown10.Value), Decimal.ToDouble(numericUpDown11.Value)) '
        If res <> 0 Then
            MessageBox.Show("dmc_change_speed_unit == " + res.ToString())
        End If
    End Sub

    Private Sub button3_Click(sender As Object, e As EventArgs) Handles button3.Click
        Dim res As Short
        res = dmc_reset_target_position_unit(_CardID, GetAxis(), Decimal.ToDouble(numericUpDown12.Value)) '
        If res <> 0 Then
            MessageBox.Show("dmc_reset_target_position_unit == " + res.ToString())
        End If
    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        Dim axis As UShort
        axis = GetAxis() '
        nmc_set_axis_enable(_CardID, axis) '
    End Sub

    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        Dim axis As UShort
        axis = GetAxis() '
        nmc_set_axis_disable(_CardID, axis) '
    End Sub

    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……")
        Button10.Enabled = False
        Button11.Enabled = False

        dmc_board_reset()
        dmc_board_close()

        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next

        dmc_board_init()
        RichTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态")
        Button10.Enabled = True
        Button11.Enabled = True
        Button10.Focus()
    End Sub

    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡软件复位进行中……")
        Button10.Enabled = False
        Button11.Enabled = False
        Dim dt_start As DateTime
        Dim res As Short
        Dim err As UShort
        dt_start = DateTime.Now
        res = dmc_soft_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_soft_reset == " + res.ToString())
            Return
        End If
        While True
            If (DateTime.Now - dt_start).TotalMilliseconds >= 10000.0 Then '设置超时退出，防止死循环
                MessageBox.Show("总线复位失败!")
                Button10.Enabled = True
                Button11.Enabled = True
                Button11.Focus()
                Return
            End If

            res = nmc_get_errcode(_CardID, 2, err)
            If res = 0 Then
                If err = 0 Then '总线复位正常完成
                    Exit While
                End If
            Else
                MessageBox.Show("nmc_get_errcode == " + res.ToString())
                Button10.Enabled = True
                Button11.Enabled = True
                Button11.Focus()
                Return
            End If
            Application.DoEvents()
        End While
        RichTextBox1.AppendText("总线卡软件复位完成,请确认总线状态")
        Button10.Enabled = True
        Button11.Enabled = True
        Button11.Focus()
    End Sub
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Stop()
        dmc_board_close()
    End Sub
End Class
