﻿Imports System.Threading

Public Class Form1
    Public _CardID As Short
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '
        _CardID = cardids(0) '
        Timer1.Start()
    End Sub
    Private Function GetAxis() As UShort
        Dim axis As UShort = 0

        If (radioButton1.Checked) Then
            axis = 0
        ElseIf (radioButton2.Checked) Then
            axis = 1
        ElseIf (radioButton3.Checked) Then
            axis = 2
        End If
        Return axis

    End Function

    Private Function GetMode() As UShort
        Dim mode As Short = 0
        If (radioButton5.Checked) Then
            mode = 1
        ElseIf (radioButton6.Checked) Then
            mode = 0
        End If
        Return mode
    End Function


    Private Sub button1_Click(sender As Object, e As EventArgs)
        dmc_set_handwheel_inmode(_CardID, GetAxis(), GetMode(), Decimal.ToInt32(numericUpDown1.Value), 0)
        dmc_handwheel_move(_CardID, GetAxis())
    End Sub

    Private Sub button2_Click(sender As Object, e As EventArgs)
        dmc_emg_stop(_CardID)
    End Sub

    Private Sub button3_Click(sender As Object, e As EventArgs) Handles button3.Click
        Me.Close()
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim errcode As Int32
        Dim Axis_State_machine0 As Int32
        Dim Axis_State_machine1 As Int32
        Dim Axis_State_machine2 As Int32
        Dim position(3) As Double
        Dim speed(3) As Double
        nmc_get_errcode(_CardID, 2, errcode)
        If (errcode = 0) Then
            TextBox13.Text = "EtherCAT总线正常"
            TextBox13.BackColor = Color.Green
        Else
            TextBox13.Text = "EtherCAT总线出错"
            TextBox13.BackColor = Color.Red
        End If
        nmc_get_axis_state_machine(_CardID, 0, Axis_State_machine0)
        Select Case (Axis_State_machine0) ' 读取指定轴状态机
            Case 0 : TextBox2.Text = "轴处于未启动状态"
                TextBox2.BackColor = Color.Red
            Case 1
                TextBox2.Text = "轴处于启动禁止状态"
                TextBox2.BackColor = Color.Red
            Case 2
                TextBox2.Text = "轴处于准备启动状态"
                TextBox2.BackColor = Color.Red
            Case 3
                TextBox2.Text = "轴处于启动状态"
                TextBox2.BackColor = Color.Red
            Case 4
                TextBox2.Text = "轴处于操作使能状态"
                TextBox2.BackColor = Color.Green
            Case 5
                TextBox2.Text = "轴处于停止状态"
                TextBox2.BackColor = Color.Red
            Case 6
                TextBox2.Text = "轴处于错误触发状态"
                TextBox2.BackColor = Color.Red
            Case 7
                TextBox2.Text = "轴处于错误状态"
                TextBox2.BackColor = Color.Red
        End Select
        nmc_get_axis_state_machine(_CardID, 1, Axis_State_machine1)
        Select Case (Axis_State_machine1) ' 读取指定轴状态机
            Case 0 : TextBox6.Text = "轴处于未启动状态"
                TextBox6.BackColor = Color.Red
            Case 1
                TextBox6.Text = "轴处于启动禁止状态"
                TextBox6.BackColor = Color.Red
            Case 2
                TextBox6.Text = "轴处于准备启动状态"
                TextBox6.BackColor = Color.Red
            Case 3
                TextBox6.Text = "轴处于启动状态"
                TextBox6.BackColor = Color.Red
            Case 4
                TextBox6.Text = "轴处于操作使能状态"
                TextBox6.BackColor = Color.Green
            Case 5
                TextBox6.Text = "轴处于停止状态"
                TextBox6.BackColor = Color.Red
            Case 6
                TextBox6.Text = "轴处于错误触发状态"
                TextBox6.BackColor = Color.Red
            Case 7
                TextBox6.Text = "轴处于错误状态"
                TextBox6.BackColor = Color.Red
        End Select
        nmc_get_axis_state_machine(_CardID, 2, Axis_State_machine2)
        Select Case (Axis_State_machine2) ' 读取指定轴状态机
            Case 0 : TextBox10.Text = "轴处于未启动状态"
                TextBox10.BackColor = Color.Red
            Case 1
                TextBox10.Text = "轴处于启动禁止状态"
                TextBox10.BackColor = Color.Red
            Case 2
                TextBox10.Text = "轴处于准备启动状态"
                TextBox10.BackColor = Color.Red
            Case 3
                TextBox10.Text = "轴处于启动状态"
                TextBox10.BackColor = Color.Red
            Case 4
                TextBox10.Text = "轴处于操作使能状态"
                TextBox10.BackColor = Color.Green
            Case 5
                TextBox10.Text = "轴处于停止状态"
                TextBox10.BackColor = Color.Red
            Case 6
                TextBox10.Text = "轴处于错误触发状态"
                TextBox10.BackColor = Color.Red
            Case 7
                TextBox10.Text = "轴处于错误状态"
                TextBox10.BackColor = Color.Red
        End Select

        For i As Short = 0 To 2 Step 1
            dmc_read_current_speed_unit(_CardID, i, position(i)) '
            dmc_get_position_unit(_CardID, i, speed(i)) '
        Next

        textBox3.Text = Str(speed(0))
        TextBox7.Text = Str(speed(1))
        TextBox11.Text = Str(speed(2))

        textBox1.Text = Str(position(0))
        TextBox8.Text = Str(position(1))
        TextBox12.Text = Str(position(2))

        If (dmc_check_done(_CardID, 0) = 0) Then
            TextBox4.Text = "运行中" '
            TextBox4.BackColor = Color.Green
        Else
            TextBox4.Text = "停止中" '
            TextBox4.BackColor = Color.Red
        End If
        If (dmc_check_done(_CardID, 1) = 0) Then
            TextBox5.Text = "运行中" '
            TextBox5.BackColor = Color.Green
        Else
            TextBox5.Text = "停止中" '
            TextBox5.BackColor = Color.Red
        End If
        If (dmc_check_done(_CardID, 2) = 0) Then
            TextBox9.Text = "运行中" '
            TextBox9.BackColor = Color.Green
        Else
            TextBox9.Text = "停止中" '
            TextBox9.BackColor = Color.Red
        End If
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Dim res As Short
        res = dmc_set_handwheel_inmode(_CardID, GetAxis(), GetMode(), Decimal.ToInt32(numericUpDown1.Value), 0) '设置手轮控制方式
        res = dmc_handwheel_move(_CardID, GetAxis()) '启动手轮控制
        If res <> 0 Then
            MessageBox.Show("dmc_handwheel_move == " + res.ToString())
        End If
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        dmc_emg_stop(_CardID) '急停
    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        Dim MyAxisNum As UShort
        Dim MyAxisList(3) As UShort
        Dim Mymulti(3) As Integer
        Dim res As Short
        MyAxisList(0) = 0
        MyAxisList(1) = 1
        MyAxisList(2) = 2 '设置参与手轮运动的轴号列表
        Mymulti(0) = 1
        Mymulti(1) = 10
        Mymulti(2) = 10 '设置轴的倍率  
        MyAxisNum = 3 '参与手轮运动的轴数
        res = dmc_set_handwheel_inmode_extern(_CardID, GetMode(), MyAxisNum, MyAxisList, Mymulti) '设置多轴手轮运动控制输入方式
        res = dmc_handwheel_move(_CardID, MyAxisList(0)) '启动手轮运动    
        If res <> 0 Then
            MessageBox.Show("dmc_handwheel_move == " + res.ToString())
        End If
    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        dmc_emg_stop(_CardID)
    End Sub

    Private Sub Button1_Click_1(sender As Object, e As EventArgs) Handles Button1.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……")
        Button1.Enabled = False
        Button2.Enabled = False

        dmc_board_reset()
        dmc_board_close()

        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next

        dmc_board_init()
        RichTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态")
        Button1.Enabled = True
        Button2.Enabled = True
        Button1.Focus()
    End Sub

    Private Sub Button2_Click_1(sender As Object, e As EventArgs) Handles Button2.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡软件复位进行中……")
        Button1.Enabled = False
        Button2.Enabled = False

        Dim dt_start As DateTime
        Dim res As Short
        Dim err As UShort
        dt_start = DateTime.Now
        res = dmc_soft_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_soft_reset == " + res.ToString())
            Return
        End If
        While True
            If (DateTime.Now - dt_start).TotalMilliseconds >= 10000.0 Then '设置超时退出，防止死循环
                MessageBox.Show("总线复位失败!")
                Button1.Enabled = True
                Button2.Enabled = True
                Button2.Focus()
                Return
            End If

            res = nmc_get_errcode(_CardID, 2, err)
            If res = 0 Then
                If err = 0 Then '总线复位正常完成
                    Exit While
                End If
            Else
                MessageBox.Show("nmc_get_errcode == " + res.ToString())
                Button1.Enabled = True
                Button2.Enabled = True
                Button2.Focus()
                Return
            End If
            Application.DoEvents()
        End While
        RichTextBox1.AppendText("总线卡软件复位完成,请确认总线状态")
        Button1.Enabled = True
        Button2.Enabled = True
        Button2.Focus()
    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click
        nmc_set_axis_enable(_CardID, 0) '
        nmc_set_axis_enable(_CardID, 1) '
        nmc_set_axis_enable(_CardID, 2) '
    End Sub

    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click
        nmc_set_axis_disable(_CardID, 0) '
        nmc_set_axis_disable(_CardID, 1) '
        nmc_set_axis_disable(_CardID, 2) '
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Stop()
        dmc_board_close()
    End Sub
End Class
