﻿Imports System.Threading

Public Class Form1
    Public _CardID As Short = 0
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim n As Short
        Dim cardtypes(8) As UInteger
        Dim cardids(8) As UShort
        n = dmc_board_init() '获取卡数量

        If (n <= 0) Or (n > 8) Then             '正常的卡数在1- 8之间
            MsgBox("初始化LTDMC卡失败！", vbOKOnly, "出错")
        Else
            MsgBox("初始化LTDMC卡成功！", vbOKOnly, "OK")
        End If
        dmc_get_CardInfList(n, cardtypes, cardids) '
        _CardID = cardids(0) '
        Timer1.Start() '

    End Sub

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        
        Dim axis(2) As UShort
        Dim pos(2) As Double
        axis(0) = 0
        axis(1) = 1
        pos(0) = 10000
        pos(1) = 10000

        dmc_set_position_unit(_CardID, 0, 0)
        dmc_set_position_unit(_CardID, 1, 0)

        dmc_compare_set_config(_CardID, 0, 1, 0) '’//设置比较器，0号卡一维位置比较使能，比较源指令位置
        dmc_compare_clear_points(_CardID, 0) '’


        dmc_compare_set_config(_CardID, 1, 1, 0) '’//设置比较器，0号卡一维位置比较使能，比较源指令位置
        dmc_compare_clear_points(_CardID, 1) '’

        Dim res As Short = 0
        Dim cycle As UShort = 0
        Dim level As UShort = 0
        Dim bitno As UInteger = 0
        res = dmc_compare_add_point_cycle_unit(_CardID, 0, 3000, 1, bitno, cycle, level) '轴0大于等于3000，0号输出口置低电平
        If res <> 0 Then
            MessageBox.Show("dmc_compare_add_point_cycle_unit ==" + res.ToString())
        End If
        level = 1
        res = dmc_compare_add_point_cycle_unit(_CardID, 1, 6000, 1, bitno, cycle, level) '轴1大于等于6000，0号输出口置高电平
        If res <> 0 Then
            MessageBox.Show("dmc_compare_add_point_cycle_unit ==" + res.ToString())
        End If

        dmc_set_vector_profile_unit(_CardID, 0, 0, 3000, 0.1, 0, 0)
        dmc_line_unit(_CardID, 0, 2, axis, pos, 1)
    End Sub

    Private Sub button3_Click(sender As Object, e As EventArgs) Handles button3.Click
        Timer1.Stop()
        dmc_board_close()
        Me.Close()
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Dim errcode As Int32
        Dim Axis_State_machine0 As Int32
        Dim Axis_State_machine1 As Int32
        nmc_get_errcode(_CardID, 2, errcode)
        If (errcode = 0) Then
            TextBox6.Text = "EtherCAT总线正常"
            TextBox6.BackColor = Color.Green
        Else
            TextBox6.Text = "EtherCAT总线出错"
            TextBox6.BackColor = Color.Red
        End If
        nmc_get_axis_state_machine(_CardID, 0, Axis_State_machine0)
        Select Case (Axis_State_machine0) ' 读取指定轴状态机

            Case 0 : TextBox4.Text = "轴处于未启动状态"
                TextBox4.BackColor = Color.Red

            Case 1
                TextBox4.Text = "轴处于启动禁止状态"
                TextBox4.BackColor = Color.Red

            Case 2
                TextBox4.Text = "轴处于准备启动状态"
                TextBox4.BackColor = Color.Red

            Case 3
                TextBox4.Text = "轴处于启动状态"
                TextBox4.BackColor = Color.Red

            Case 4
                TextBox4.Text = "轴处于操作使能状态"
                TextBox4.BackColor = Color.Green

            Case 5
                TextBox4.Text = "轴处于停止状态"
                TextBox4.BackColor = Color.Red

            Case 6
                TextBox4.Text = "轴处于错误触发状态"
                TextBox4.BackColor = Color.Red

            Case 7
                TextBox4.Text = "轴处于错误状态"
                TextBox4.BackColor = Color.Red

        End Select
        nmc_get_axis_state_machine(_CardID, 1, Axis_State_machine1)
        Select Case (Axis_State_machine1) ' 读取指定轴状态机

            Case 0 : TextBox5.Text = "轴处于未启动状态"
                TextBox5.BackColor = Color.Red

            Case 1
                TextBox5.Text = "轴处于启动禁止状态"
                TextBox5.BackColor = Color.Red

            Case 2
                TextBox5.Text = "轴处于准备启动状态"
                TextBox5.BackColor = Color.Red

            Case 3
                TextBox5.Text = "轴处于启动状态"
                TextBox5.BackColor = Color.Red

            Case 4
                TextBox5.Text = "轴处于操作使能状态"
                TextBox5.BackColor = Color.Green

            Case 5
                TextBox5.Text = "轴处于停止状态"
                TextBox5.BackColor = Color.Red

            Case 6
                TextBox5.Text = "轴处于错误触发状态"
                TextBox5.BackColor = Color.Red

            Case 7
                TextBox5.Text = "轴处于错误状态"
                TextBox5.BackColor = Color.Red

        End Select



        Dim posx As Double
        Dim posy As Double

        dmc_get_position_unit(_CardID, 0, posx)
        dmc_get_position_unit(_CardID, 1, posy)

        textBox1.Text = posx.ToString()
        textBox2.Text = posy.ToString()

        If (dmc_check_done(_CardID, 0) = 0) Or (dmc_check_done(_CardID, 1) = 0) Then
            textBox3.Text = "运动中"
        Else
            textBox3.Text = "停止中"
        End If

        If (dmc_read_outbit(_CardID, 0) = 0) Then
            panel1.BackColor = Color.Green
        Else
            panel1.BackColor = Color.Red
        End If

    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡硬件复位进行中……")
        Button6.Enabled = False
        Button7.Enabled = False

        dmc_board_reset()
        dmc_board_close()

        For i As Integer = 0 To 15 Step 1 '总线卡硬件复位耗时15s左右
            Application.DoEvents()
            Thread.Sleep(1000)
        Next

        dmc_board_init()
        RichTextBox1.AppendText("总线卡硬件复位完成,请确认总线状态")
        Button6.Enabled = True
        Button7.Enabled = True
        Button6.Focus()
    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click
        RichTextBox1.Text = ""
        RichTextBox1.AppendText("请勿操作，总线卡软件复位进行中……")
        Button6.Enabled = False
        Button7.Enabled = False

        Dim dt_start As DateTime
        Dim res As Short
        Dim err As UShort
        dt_start = DateTime.Now
        res = dmc_soft_reset(_CardID)
        If res <> 0 Then
            MessageBox.Show("dmc_soft_reset == " + res.ToString())
            Return
        End If
        While True
            If (DateTime.Now - dt_start).TotalMilliseconds >= 10000.0 Then '设置超时退出，防止死循环
                MessageBox.Show("总线复位失败!")
                Button6.Enabled = True
                Button7.Enabled = True
                Button7.Focus()
                Return
            End If

            res = nmc_get_errcode(_CardID, 2, err)
            If res = 0 Then
                If err = 0 Then '总线复位正常完成
                    Exit While
                End If
            Else
                MessageBox.Show("nmc_get_errcode == " + res.ToString())
                Button6.Enabled = True
                Button7.Enabled = True
                Button7.Focus()
                Return
            End If
            Application.DoEvents()
        End While
        RichTextBox1.AppendText("总线卡软件复位完成,请确认总线状态")
        Button6.Enabled = True
        Button7.Enabled = True
        Button7.Focus()
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        nmc_set_axis_enable(_CardID, 0)
        nmc_set_axis_enable(_CardID, 1)
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        nmc_set_axis_disable(_CardID, 0)
        nmc_set_axis_disable(_CardID, 1)
    End Sub
End Class
