// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"
#include<math.h>
#include <process.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
	m_nAxis = 0;
	m_selx = 0;
	m_sely = 0;
	m_error_x = 0.0;
	m_error_y = 0.0;
	m_time = 0.0;
	m_duty = 0.0;
	m_freq = 0.0;
	m_num = 0;
	m_forceio = 0;
	m_check_pwm = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	DDX_Control(pDX, IDC_LIST_INFO, m_datalist);
	DDX_Control(pDX, IDC_COMBO_CMPLOGIC, m_combo_logic);
	DDX_Control(pDX, IDC_COMBO_CMPMODE, m_combo_mode);
	DDX_Text(pDX, IDC_EDIT_SELX, m_selx);
	DDX_Text(pDX, IDC_EDIT_SELY, m_sely);
	DDX_Text(pDX, IDC_EDIT_ERRORX, m_error_x);
	DDX_Text(pDX, IDC_EDIT_ERRORY, m_error_y);
	DDX_Text(pDX, IDC_EDIT_CMPTIME, m_time);
	DDX_Text(pDX, IDC_EDIT_PWMDUTY, m_duty);
	DDX_Text(pDX, IDC_EDIT_PWMFREQ, m_freq);
	DDX_Text(pDX, IDC_EDIT_PWMNUM, m_num);
	DDX_Text(pDX, IDC_EDIT_FORCEIO, m_forceio);
	DDX_Check(pDX, IDC_CHECK_PWM, m_check_pwm);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_SETCMP, OnButtonSetcmp)
	ON_BN_CLICKED(IDC_BUTTON_CLEARPOINT, OnButtonClearpoint)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	ON_BN_CLICKED(IDC_BUTTON_BOARD_RESET, OnButtonBoardReset)
	ON_BN_CLICKED(IDC_BUTTON_CMP_ENABLE, OnButtonCmpEnable)
	ON_BN_CLICKED(IDC_BUTTON_CMP_DISENABLE, OnButtonCmpDisenable)
	ON_BN_CLICKED(IDC_BUTTON_FORCEOUT, OnButtonForceout)
	ON_BN_CLICKED(IDC_BUTTON_ADDPOINTS, OnButtonAddpoints)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	    SetTimer( IDC_TIMER, 100, NULL );

    InitList();
	RefreshList();
    m_num = 1;
	m_selx = 0;
	m_sely = 1;
	m_time = 1000;
	m_freq = 2;
	m_duty = 0.5;
	m_error_x = 0;
	m_error_y = 0;
	m_forceio = 0;
    m_combo_mode.SetCurSel(0);
	m_combo_logic.SetCurSel(1);
	m_check_pwm = false;
	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString string;
	double position = 0;
	DWORD dwEnd = 0;
	int iret = 0;
   	int axisX = 0;
   	int axisY = 1;
	int axisZ = 2;

	iret = dmc_get_position_unit( m_nCard,axisX,&position);          //ȡǰλ
	string.Format("Xλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION_0 )->SetWindowText( string );
	iret = dmc_get_position_unit( m_nCard,axisY,&position);          //ȡǰλ
	string.Format("Yλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION_1 )->SetWindowText( string );



	WORD hcmp = 0;
    int remained_points = 0;
	double x_current_point = 0;
	double y_current_point = 0;
	int runned_points = 0;
	WORD current_state = 0;   
	WORD current_outbit = 0;
	dmc_hcmp_2d_get_current_state_unit(m_nCard, hcmp, &remained_points, &x_current_point, &y_current_point, &runned_points, &current_state,&current_outbit);
    string.Format("remained_points:%d\r\nx_current_point:%f\r\ny_current_point:%f\r\nrunned_points:%d\r\ncurrent_state:%d\r\current_outbit:%d ", remained_points,x_current_point,
		y_current_point,runned_points,current_state,current_outbit);
	GetDlgItem( IDC_STATIC_CMP_STATUS )->SetWindowText( string );
/*	 unsigned short Axis_State_machine = 0;
    nmc_get_axis_state_machine(m_nCard, m_nAxis, &Axis_State_machine);
   	CStatic *Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS);
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };*/

	 unsigned short errcode = 1;
     nmc_get_errcode(m_nCard,2,&errcode);
  	 CStatic *Static1= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
     if (errcode == 0)
	 {
		
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT" );
         Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	 }
	 else
	 {
		 
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT߳" );
         Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
     }

	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
   //λ
    dmc_set_position_unit(m_nCard, 0, 0);

    dmc_set_profile_unit(m_nCard, 0, 0, 10000, 0.1, 0.1, 0);

    dmc_pmove_unit(m_nCard, 0, 50000, 1);

	UpdateData(false);
}


void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	for (int i=0;i<8;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

	
}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

    dmc_emg_stop(m_nCard); //ֹͣ
	
}


void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	m_flag = 1;
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}


void CDMCd1Dlg::OnButtonSetcmp() 
{
	// TODO: Add your control notification handler code here
     UpdateData(true);
     short iret = 0;
	 WORD pwm_enable = 0;
	 WORD cmp_mode = 0;
	 WORD cmp_logic = 0;
	 if(m_check_pwm)
	 {
		 pwm_enable = 1;
	 }
     cmp_mode = m_combo_mode.GetCurSel();
     cmp_logic = m_combo_logic.GetCurSel();
     iret = dmc_hcmp_2d_set_config_unit(m_nCard,0, cmp_mode,m_selx, 1,m_error_x, m_sely, 1, m_error_y, cmp_logic,m_time);	 
	 iret = dmc_hcmp_2d_set_pwmoutput(m_nCard,0, pwm_enable, m_duty,m_freq,m_num);

}





void CDMCd1Dlg::OnButtonClearpoint() 
{
	// TODO: Add your control notification handler code here
	short iret = 0;
    unsigned short hcmp = 0;  
    iret = dmc_hcmp_2d_clear_points(m_nCard, 0);

}



void CDMCd1Dlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here
	nmc_set_axis_enable(m_nCard, 0);
	nmc_set_axis_enable(m_nCard, 1);
	nmc_set_axis_enable(m_nCard, 2);
}

void CDMCd1Dlg::OnButtonDisable() 
{
	// TODO: Add your control notification handler code here
	nmc_set_axis_disable(m_nCard, 0);
	nmc_set_axis_disable(m_nCard, 1);
	nmc_set_axis_disable(m_nCard, 2);
}

void CDMCd1Dlg::OnButtonSoftReset() 
{	

	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ȸλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ȸλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}

void CDMCd1Dlg::OnButtonBoardReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿临λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_cool_reset(m_nCard);
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿临λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);
}

void CDMCd1Dlg::OnButtonCmpEnable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²

	short iret = 0;
	iret =  dmc_hcmp_2d_set_enable(m_nCard, 0, 1);

}

void CDMCd1Dlg::OnButtonCmpDisenable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	
	short iret = 0;
	iret =  dmc_hcmp_2d_set_enable(m_nCard, 0, 0);
}

void CDMCd1Dlg::OnButtonForceout() 
{
	// TODO: Add your control notification handler code here
	WORD hcmp = 0;
	short iret = 0;            
    iret = dmc_hcmp_2d_force_output(m_nCard, hcmp, m_forceio);
}

void CDMCd1Dlg::OnButtonAddpoints() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	WORD hcmp = 0;
	short iret = 0;   
	int i = 0;
	for(i = 0;i<4;i++)
	{
       iret = dmc_hcmp_2d_add_point_unit(m_nCard, hcmp,  m_x_cmp_pos[i],  m_y_cmp_pos[i], m_cmp_outbit[i]);
	}
}

void CDMCd1Dlg::InitList()
{

	//ʼб
	
	m_datalist.SetExtendedStyle(LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT);
	 
	m_datalist.InsertColumn(0,"",LVCFMT_CENTER);//ͷ
	m_datalist.InsertColumn(1,"XȽλ",LVCFMT_CENTER);//ͷ
	m_datalist.InsertColumn(2,"yȽλ",LVCFMT_CENTER);
	m_datalist.InsertColumn(3,"IO",LVCFMT_CENTER);
	
	m_datalist.SetColumnWidth(0,40);//
	m_datalist.SetColumnWidth(1,100);
	m_datalist.SetColumnWidth(2,100);
	m_datalist.SetColumnWidth(3,85);
	m_x_cmp_pos[0]=1000;
    m_x_cmp_pos[1]=2000;
	m_x_cmp_pos[2]=3000;
	m_x_cmp_pos[3]=4000;

	m_y_cmp_pos[0]=1000;
	m_y_cmp_pos[1]=2000;
	m_y_cmp_pos[2]=3000;
	m_y_cmp_pos[3]=4000;

	m_cmp_outbit[0]=0;
	m_cmp_outbit[1]=1;
	m_cmp_outbit[2]=2;
	m_cmp_outbit[3]=3;
}

void CDMCd1Dlg::RefreshList()
{
	int i = 0;
	CString strIndex;
    CString strXpos;
    CString strYpos;
    CString strOubit;
	
    double _Pos[11];
    double _Speed[11];
	m_datalist.DeleteAllItems();

	for( i = 0;i < 4; i++) 
	{  
		strIndex.Format("%d", i);  
        strXpos.Format("%.2f", m_x_cmp_pos[i]);  
		strYpos.Format("%.2f", m_y_cmp_pos[i]);  
		strOubit.Format("%d", m_cmp_outbit[i]);  
		
		m_datalist.InsertItem(i, strIndex);                          //   
        m_datalist.SetItemText(i, 1, strXpos);                     // õ2  
        m_datalist.SetItemText(i, 2, strYpos);                      // õ3 
        m_datalist.SetItemText(i, 3, strOubit);                      // õ4
	}
}
