// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
	m_nAxis = 0;
	m_nAcc = 0.1;
	m_nDec = 0.1;
	m_nSPara = 0.0;
	m_nSpeed = 0.0;
	m_nSpeedMin = 0.0;
	m_equiv = 0.0;
	m_stopvel = 0.0;
	m_nPulse = 0.0;
	m_dir = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	DDX_Control(pDX, IDC_COMBO_AXISNO, m_combox_axisno);
	DDX_Text(pDX, IDC_EDIT_ACC, m_nAcc);
	DDX_Text(pDX, IDC_EDIT_DEC, m_nDec);
	DDX_Text(pDX, IDC_EDIT_SPara, m_nSPara);
	DDX_Text(pDX, IDC_EDIT_SPEED, m_nSpeed);
	DDX_Text(pDX, IDC_EDIT_SPEEDMin, m_nSpeedMin);
	DDX_Text(pDX, IDC_EDIT_EQUIV, m_equiv);
	DDX_Text(pDX, IDC_EDIT_STOPVEL, m_stopvel);
	DDX_Text(pDX, IDC_EDIT_PULSE, m_nPulse);
	DDX_Radio(pDX, IDC_RADIO_P, m_dir);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_BN_CLICKED(IDC_BUTTON_EMGSTOP, OnButtonEmgstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CHANGESPEED, OnButtonChangespeed)
	ON_BN_CLICKED(IDC_BUTTON_SETEQUIV, OnButtonSetequiv)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	    SetTimer( IDC_TIMER, 100, NULL );

	m_nSpeed=3000;
	m_nSpeedMin=1000;
	m_nAcc=0.01;
	m_nDec=0.01;
	m_nSPara= 0;      //ʼٶ߲
	m_equiv = 1;
	m_stopvel = 0;
	m_nPulse = 5000;
	m_combox_axisno.SetCurSel(0);
	m_dir = 0;
	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
//	GetDlgItem( IDC_CHECK_LOGIC )->SetWindowText( m_bLogic?"߼":"߼򣺷");
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString string;
	double position = 0;
	int iret = 0;
	iret = dmc_get_position_unit( m_nCard,m_nAxis,&position);          //ȡǰλ
	string.Format("ǰλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION )->SetWindowText( string );

    double NewSpeed = 0;
	iret = dmc_read_current_speed_unit( m_nCard,m_nAxis,&NewSpeed );          //ȡǰٶ
	string.Format("ǰٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe)->SetWindowText( string );

	DWORD status = dmc_check_done(m_nCard, m_nAxis );           //жϵǰ״̬
	if (status == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS )->SetWindowText( "ǰ״̬˶" );
	}
	unsigned short Axis_State_machine = 0;
    nmc_get_axis_state_machine(m_nCard, m_nAxis, &Axis_State_machine);
   	CStatic *Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS);
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };

	 unsigned short errcode = 1;
     nmc_get_errcode(m_nCard,2,&errcode);
  	 CStatic *Static1= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
     if (errcode == 0)
	 {
		
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT" );
         Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	 }
	 else
	 {
		 
		 GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT߳" );
         Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
     }
	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	//////////////////////////
    int dir = 0;//
	m_nAxis = m_combox_axisno.GetCurSel();
	
	if (dmc_check_done( m_nCard,m_nAxis ) == 0) //Ѿ˶
		return; 	
	dmc_set_profile_unit(m_nCard,m_nAxis,m_nSpeedMin,m_nSpeed,m_nAcc,m_nDec,m_stopvel);
	//趨Sʱ
	dmc_set_s_profile(m_nCard,m_nAxis,0,m_nSPara);
	//㶯(λģʽ)
	if(m_dir==0)
	{
		dir = 1;//
	}
	dmc_vmove(m_nCard, m_nAxis, dir);
	
	UpdateData(false);
}

void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	for (int i=0;i<8;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

	
}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

	m_nAxis = m_combox_axisno.GetCurSel();
	dmc_stop(m_nCard,m_nAxis,0);          //ֹͣ
	
}

void CDMCd1Dlg::OnButtonEmgstop() 
{
	// TODO: Add your control notification handler code here
	//ȫͣ
	dmc_emg_stop(m_nCard);
	
}



void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}
 


void CDMCd1Dlg::OnButtonChangespeed() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²

	m_nAxis = m_combox_axisno.GetCurSel();

	dmc_change_speed_unit(m_nCard, m_nAxis, m_nSpeed, m_nAcc);  

}


void CDMCd1Dlg::OnButtonSetequiv() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	m_nAxis = m_combox_axisno.GetCurSel();
	dmc_set_equiv(m_nCard,m_nAxis,m_equiv);          
}

void CDMCd1Dlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	m_nAxis = m_combox_axisno.GetCurSel();
	nmc_set_axis_enable(m_nCard, m_nAxis);
}

void CDMCd1Dlg::OnButtonDisable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²	
	m_nAxis = m_combox_axisno.GetCurSel();
	nmc_set_axis_disable(m_nCard, m_nAxis);
}

void CDMCd1Dlg::OnButtonReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ӲλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_board_reset();
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿Ӳλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);
}

void CDMCd1Dlg::OnButtonSoftReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);
}
