// DMCd1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "DMCd1.h"
#include "DMCd1Dlg.h"
#include "LTDMC.h"
#include<math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg dialog

CDMCd1Dlg::CDMCd1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDMCd1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDMCd1Dlg)
	m_nAxis = 0;
	m_dataradio = -1;
	m_pvtmode = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDMCd1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDMCd1Dlg)
	DDX_Control(pDX, IDC_COMBO_AXISNO_2, m_combox_axisno2);
	DDX_Control(pDX, IDC_COMBO_AXISNO_1, m_combox_axisno1);
	DDX_Control(pDX, IDC_COMBO_AXISNO_0, m_combox_axisno0);
	DDX_Control(pDX, IDC_LIST_INFO, m_datalist);
	DDX_Radio(pDX, IDC_RADIO_X, m_dataradio);
	DDX_Radio(pDX, IDC_RADIO_PVT, m_pvtmode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDMCd1Dlg, CDialog)
	//{{AFX_MSG_MAP(CDMCd1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_DECSTOP, OnButtonDecstop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIO_X, OnRadioX)
	ON_BN_CLICKED(IDC_RADIO_Y, OnRadioY)
	ON_BN_CLICKED(IDC_RADIO_Z, OnRadioZ)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_SOFT_RESET, OnButtonSoftReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDMCd1Dlg message handlers

BOOL CDMCd1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	WORD My_CardNum ;      //忨
	WORD My_CardList[8];   //忨
	DWORD My_CardTypeList[8];   //
	if( dmc_board_init() <= 0 )      //ƿĳʼ
		MessageBox("ʼƿʧܣ","");
	dmc_get_CardInfList(&My_CardNum, My_CardTypeList, My_CardList);    //ȡʹõĿб
	m_nCard = My_CardList[0]; 
		UpdateControl();
	    SetTimer( IDC_TIMER, 100, NULL );

    m_combox_axisno0.SetCurSel(0);
	m_combox_axisno1.SetCurSel(1);
	m_combox_axisno2.SetCurSel(2);
    m_dataradio = 0;
	m_pvtmode = 0;
    InitList();
	RefreshList();

	CString strtime;
	passTime = 0;
	strtime.Format("ʱ:%.2f", passTime);
	GetDlgItem( IDC_STATIC_TIME )->SetWindowText( strtime );

	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDMCd1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDMCd1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDMCd1Dlg::UpdateControl()
{
}

void CDMCd1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString string;
	double position = 0;
	DWORD dwEnd = 0;
	int iret = 0;
   	int axisX = 0;
   	int axisY = 1;
	int axisZ = 2;
	axisX = m_combox_axisno0.GetCurSel();	
    axisY = m_combox_axisno1.GetCurSel();
	axisZ = m_combox_axisno2.GetCurSel();

	iret = dmc_get_position_unit( m_nCard,axisX,&position);          //ȡǰλ
	string.Format("Xλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION_0 )->SetWindowText( string );

	iret = dmc_get_position_unit( m_nCard,axisY,&position);          //ȡǰλ
	string.Format("Yλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION_1 )->SetWindowText( string );

	iret = dmc_get_position_unit( m_nCard,axisZ,&position);          //ȡǰλ
	string.Format("Zλã%.2f", position );
	GetDlgItem( IDC_STATIC_POSITION_2 )->SetWindowText( string );

    double NewSpeed = 0;
	iret = dmc_read_current_speed_unit( m_nCard,axisX,&NewSpeed );          //ȡǰٶ
	string.Format("Xٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe_0)->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,axisY,&NewSpeed );          //ȡǰٶ
	string.Format("Yٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe_1)->SetWindowText( string );

	iret = dmc_read_current_speed_unit( m_nCard,axisZ,&NewSpeed );          //ȡǰٶ
	string.Format("Zٶȣ%.2f", NewSpeed );
	GetDlgItem( IDC_STATIC_NowSpe_2)->SetWindowText( string );

	DWORD status0 = dmc_check_done(m_nCard, axisX );           //жϵǰ״̬
	if (status0 == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS_0 )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS_0 )->SetWindowText( "ǰ״̬˶" );
	}

    DWORD status1 = dmc_check_done(m_nCard, axisY );           //жϵǰ״̬
	if (status1 == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS_1 )->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS_1 )->SetWindowText( "ǰ״̬˶" );
	}

    DWORD status2 = dmc_check_done(m_nCard, axisZ );           //жϵǰ״̬
	if (status2 == 1)
	{
		GetDlgItem( IDC_STATIC_STATUS_2)->SetWindowText( "ǰ״ֹ̬" );
	}else
	{
		GetDlgItem( IDC_STATIC_STATUS_2 )->SetWindowText( "ǰ״̬˶" );
	}

	//Լ㾭ʱ
	if(status0!=1||status1!=1||status2!=1)
	{
		dwEnd = GetTickCount();
	    passTime = (dwEnd -m_dwStart)/1000.0 ;

    	CString strtime;
    	strtime.Format("ʱ:%.2f", passTime);
	    GetDlgItem( IDC_STATIC_TIME )->SetWindowText( strtime );
	}

	unsigned short Axis_State_machine = 0;
	unsigned short Axis_State_machine1 = 0;
	unsigned short Axis_State_machine2 = 0;

    nmc_get_axis_state_machine(m_nCard, axisX,  &Axis_State_machine);
	nmc_get_axis_state_machine(m_nCard, axisY, &Axis_State_machine1);
	nmc_get_axis_state_machine(m_nCard, axisZ, &Axis_State_machine2);

   	CStatic *Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS1);	
	
	switch (Axis_State_machine)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine1 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };
	Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS2);	
   
    switch (Axis_State_machine1)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine2 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };
    Static0= (CStatic *)GetDlgItem(IDC_STATIC_PIC_STATUS3);
	switch (Axis_State_machine2)// ȡָ״̬
    {
	case 0: 
		 GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦδ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 1:
	     GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦֹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	case 2:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦ׼״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 3:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 4:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڲʹ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
         break; 
	case 5:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦֹͣ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 6:
         GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڴ󴥷״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break; 
	case 7:
	     GetDlgItem( IDC_STATIC_state_machine3 )->SetWindowText( "ᴦڴ״̬" );
         Static0->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
         break;
	default:
		break;
    };

    unsigned short errcode = 1;
    nmc_get_errcode(m_nCard,2,&errcode);
  	CStatic *Static1= (CStatic *)GetDlgItem(IDC_STATIC_PIC_BUS);
    if (errcode == 0)
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_GREEN));
	}
	else
	{
		GetDlgItem( IDC_STATIC_BUS_STATE )->SetWindowText( "״̬EtherCAT߳" );
        Static1->SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_RED));
    }	

	CDialog::OnTimer(nIDEvent);
}

void CDMCd1Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	short iret = 0;
	int axisX = 0;
   	int axisY = 1;
	int axisZ = 2;
    int i = 0;
	DWORD m_posLength ;
	unsigned short axislist[3];
    long m_PosX[11];
    long m_PosY[11];
    long m_PosZ[11];
	axisX = m_combox_axisno0.GetCurSel();	
    axisY = m_combox_axisno1.GetCurSel();
	axisZ = m_combox_axisno2.GetCurSel();

    axislist[0] = axisX;
    axislist[1] = axisY;
    axislist[2] = axisZ;
    m_posLength = m_count;
   	for(i = 0;i<m_count;i++)
	{
		m_PosX[i] = _PosX[i];
		m_PosY[i] = _PosY[i];
		m_PosZ[i] = _PosZ[i];
	}

	if (m_pvtmode ==0 )
	{
		dmc_PvtTable(m_nCard, axisX, m_posLength, _Time, m_PosX, _SpeedX);
        dmc_PvtTable(m_nCard, axisY,  m_posLength, _Time, m_PosY, _SpeedY);
        dmc_PvtTable(m_nCard, axisZ, m_posLength, _Time, m_PosZ, _SpeedZ);
    }
	else
    {
		dmc_PvtsTable(m_nCard, axisX, m_posLength, _Time, m_PosX, 0, 0);
        dmc_PvtsTable(m_nCard, axisY, m_posLength, _Time, m_PosY, 0, 0);
        dmc_PvtsTable(m_nCard, axisZ, m_posLength, _Time, m_PosZ, 0, 0);
    }
 
    iret = dmc_PvtMove(m_nCard, 3, axislist);

	//ʱ
	passTime = 0;
    m_dwStart = GetTickCount();

	UpdateData(false);
}

void CDMCd1Dlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	for (int i=0;i<8;i++) 
	{
		dmc_set_position_unit(m_nCard,i,0);        //
	}

	
}

void CDMCd1Dlg::OnButtonDecstop() 
{
	// TODO: Add your control notification handler code here

    dmc_emg_stop(m_nCard); //ֹͣ
	
}


void CDMCd1Dlg::OnDestroy() 
{
	// TODO: Add your message handler code here
	dmc_board_close();	//ǳ֮ҪͷռõϵͳԴ
	KillTimer( IDC_TIMER );
	CDialog::OnDestroy();
	
}
 


void CDMCd1Dlg::RefreshList()
{
    int i = 0;
	CString strIndex;
    CString strPos;
    CString strTime;
    CString strVel;

    double _Pos[11];
    double _Speed[11];
	 m_datalist.DeleteAllItems();
	switch(m_dataradio)
	{
	case 0:
		for(i = 0;i<m_count;i++)
		{
			_Pos[i] = _PosX[i];
			_Speed[i] = _SpeedX[i];
		}
		break;
	case 1:
		for(i = 0;i<m_count;i++)
		{
			_Pos[i] = _PosY[i];
			_Speed[i] = _SpeedY[i];
		}
		break;
	case 2:
		for(i = 0;i<m_count;i++)
		{
			_Pos[i] = _PosZ[i];
			_Speed[i] = _SpeedZ[i];
		}
		break;

	default:
		break;
	}
	for( i = 0;i < m_count; i++) 
	{  
		strIndex.Format("%d", i);  
        strPos.Format("%.2f", _Pos[i]);  
		strTime.Format("%.2f", _Time[i]);  
		strVel.Format("%.2f", _Speed[i]);  

		m_datalist.InsertItem(i, strIndex);                          //   
        m_datalist.SetItemText(i, 1, strPos);                     // õ2  
        m_datalist.SetItemText(i, 2, strTime);                      // õ3 
        m_datalist.SetItemText(i, 3, strVel);                      // õ4
	}

}

void CDMCd1Dlg::InitList()
{
   //ʼб

   m_datalist.SetExtendedStyle(LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT);

   m_datalist.InsertColumn(0,"",LVCFMT_CENTER);//ͷ
   m_datalist.InsertColumn(1,"λ(pulse)",LVCFMT_CENTER);
   m_datalist.InsertColumn(2,"ʱ(s)",LVCFMT_CENTER);
   m_datalist.InsertColumn(3,"ٶ(pulse/s)",LVCFMT_CENTER);

   m_datalist.SetColumnWidth(0,58);//
   m_datalist.SetColumnWidth(1,105);
   m_datalist.SetColumnWidth(2,90);
   m_datalist.SetColumnWidth(3,95);
   
   //
   int i = 0;
   m_count = 11;
   int count = m_count;
   double r = 15000;
   const double PI = 3.14159265358979323846;

   for ( i = 0; i < count; i++)
   {
	   _PosX[i] = (r * cos(PI / 6) * cos((10 - i) * PI / 10) + r * cos(PI / 6));
       _PosY[i] = (r * sin(PI / 6) * cos((10 - i) * PI / 10) + r * sin(PI / 6));
       _PosZ[i] = (r * sin((10 - i) * PI / 10));
   }
   for ( i = 0; i < count; i++)
   {
	   _Time[i] = i;
   }
   double vel = - PI / 10;
   for ( i = 1; i < count - 1; i++)
   {
	   _SpeedX[i] = -r * cos(PI / 6) * sin((10 - i) * PI / 10) * vel;
       _SpeedY[i] = -r * sin(PI / 6) * sin((10 - i) * PI / 10) * vel;
       _SpeedZ[i] = r * cos((10 - i) * PI / 10) * vel;
    }
    _SpeedX[0] = 0;
    _SpeedY[0] = 0;
    _SpeedZ[0] = 0;
    _SpeedX[count - 1] = 0;
    _SpeedY[count - 1] = 0;
    _SpeedZ[count - 1] = 0;
   
}

void CDMCd1Dlg::OnRadioX() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	RefreshList();
	UpdateData(false);
	
}

void CDMCd1Dlg::OnRadioY() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	RefreshList();
	UpdateData(false);
}

void CDMCd1Dlg::OnRadioZ() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	RefreshList();
	UpdateData(false);
}

void CDMCd1Dlg::OnButtonEnable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²
	int axisX = 0;
   	int axisY = 1;
	int axisZ = 2;

	axisX = m_combox_axisno0.GetCurSel();	
    axisY = m_combox_axisno1.GetCurSel();
	axisZ = m_combox_axisno2.GetCurSel();
		
	nmc_set_axis_enable(m_nCard, axisX);		
	nmc_set_axis_enable(m_nCard, axisY);
	nmc_set_axis_enable(m_nCard, axisZ);
}

void CDMCd1Dlg::OnButtonDisable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);//ˢ²	
	int axisX = 0;
   	int axisY = 1;
	int axisZ = 2;

	axisX = m_combox_axisno0.GetCurSel();	
    axisY = m_combox_axisno1.GetCurSel();
	axisZ = m_combox_axisno2.GetCurSel();
		

	nmc_set_axis_disable(m_nCard, axisX);
	nmc_set_axis_disable(m_nCard, axisY);
	nmc_set_axis_disable(m_nCard, axisZ);	
}

void CDMCd1Dlg::OnButtonReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿ӲλС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_board_reset();
    dmc_board_close();
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		Sleep(1000);
    }
	dmc_board_init();
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿Ӳλ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}

void CDMCd1Dlg::OnButtonSoftReset() 
{
	// TODO: Add your control notification handler code here
    int i = 0;
	unsigned short errcode = 1;
	GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λС" );
    GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(false);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(false);
	dmc_soft_reset(m_nCard);
	for ( i = 0; i < 15; i++)//߿Ӳλʱ15s
    {
		nmc_get_errcode(m_nCard,2,&errcode);
		if(errcode==0)
		{
			break;
		}
		Sleep(1000);
    }
    GetDlgItem( IDC_STATIC_MSG )->SetWindowText( "߿λ,ȷ״̬" );
	GetDlgItem(IDC_BUTTON_RESET)->EnableWindow(true);
	GetDlgItem(IDC_BUTTON_SOFT_RESET)->EnableWindow(true);	
}
